#ifndef _COLOR_HEADER_
#define _COLOR_HEADER_

#define HW_COLOR(color) ((DWORD(color.alpha)<<24) + (DWORD(color.red)<<16) + (DWORD(color.green)<<8) + DWORD(color.blue))//convert to int
#define TO_COLOR(color) Color(((color)>>16)&0xFF, ((color)>>8)&0xFF, (color)&0xFF, (color)>>24)//convert from int 

struct Color
{
public:
	Color();
	~Color();

	Color(unsigned char aRed, unsigned char aGreen, unsigned char aBlue, unsigned char anAlpha = 255);
	bool operator==(const Color &aColor) const;
	bool operator!=(const Color &aColor) const;

	static const Color White()
	{
		return Color(255, 255, 255);
	}

	static const Color Black()
	{
		return Color(0, 0, 0);
	}

	static const Color LightGray()
	{
		return Color(192,192,192);
	}

	static const Color Gray()
	{
		return Color(128, 128, 128);
	}

	static const Color DarkGray()
	{
		return Color(64, 64, 64);
	}

	static const Color Red()
	{
		return Color(255, 0, 0);
	}
	
	static const Color Green()
	{
		return Color(0, 255, 0);
	}

	static const Color Blue()
	{
		return Color(0, 0, 255);
	}

	static const Color DarkBlue()
	{
		return Color(0, 0, 139);
	}

	static const Color Cyan()
	{
		return Color(0, 255, 255);
	}

	static const Color Yellow()
	{
		return Color(255, 255, 0);
	}

	static const Color Magenta()
	{
		return Color(255, 0, 255);
	}

	static const Color Turqoise()
	{
		return Color(64, 224, 208);
	}

	unsigned char red;
	unsigned char green;
	unsigned char blue;
	unsigned char alpha;
};

#endif