#ifndef _ANIMATION_H_
#define _ANIMATION_H_
#include <string>
#include <vector>
#include "HGE\hge.h"
#include "HGE\hgeSprite.h"
#include "Vector2.h"
#include "Arrays\GrowingArray.h"

class Animation
{
public:
	Animation();
	Animation(									// denna konstruktor r fr animation genom en sheet remsa
		HGE* aHGE,
		std::string aSheetFile,
		int aNumberOfSprite,
		float aFrameElapseTime
		);
		Animation(const Animation& aAnimation);
	~Animation();

	void Initilize();


	void SetPosition(float aPositionX, float aPositionY);
	void SetActiveSheet( int aSheetIndex );
	void AddSpriteSheet(std::string aSheetName);
	void SetNumberOfSprite(int aNumberOfSprite);
	void SetFrameElapseTime(float aFrameElapseTime);

	Vector2<float> GetPosition();
	float GetSpriteWidth();
	float GetSpriteHeight();

	void Logic(float deltaTime);
	void Render(float deltaTime);

private:
	// gemensamt instanser
	HGE* myHGE;
	HTEXTURE myTexture;
	Tools::GrowingArray<HTEXTURE, int> myHTEXTUREList;

	hgeSprite* mySprite;

	int myActiveSheet;
	int myCurrentSprite;

	// instance for sheet sprite animation
	float myCurrentCornerX;
	int myNumberOfSprite;
	float myFrameElapseTime;

	Vector2<float> myPosition;
	Vector2<float> myOrigo;
	Vector2<float> myScale;
	float myRotation;

	float mySpriteWidth;
	float mySpriteHeight;

	float myTextureWidth; 
	float myTextureHeight;

	// undertiden
	float myTimer; 

};
#endif