#ifndef _ANIMATION_BASE_H_
#define _ANIMATION_BASE_H_

#include "sprite.h"
#include <string>
#include <vector>
#include "Arrays\GrowingArray.h"

class AnimationBase :
	public Sprite
{
public:
	AnimationBase();
	AnimationBase(HGE* aHge);
	AnimationBase(const AnimationBase& aAnimationBase);
	virtual ~AnimationBase();

	void SetActiveSheet( int aActiveSheetIndex );
	void AddSpriteSheet(std::string aSheetName, int aNumberOfSprite, float aFrameElapseTime);

	int GetActiveSheet();
	int GetLastAnimationIndex();

	void Play();
	void Pause();

	void Initialize();
	void Update(float aDeltaTime);
	void Render(float aDeltaTime);
	void RenderAtPosition(float aDeltaTime, Vector2<float> aPosition);
protected:
	Tools::GrowingArray<HTEXTURE, int> mySheetList;
	Tools::GrowingArray<int, int> myNumberOfSpriteList;
	Tools::GrowingArray<float, int> myFrameElapseTimeList;
	Tools::GrowingArray<float, int> myCurrentSpriteWidthList;
	
	int myNumberOfSprite;
	float myFrameElapseTime;

	int myActiveSheet;
	int myCurrentSprite;
	unsigned int myNumberOfSheet;

	bool myPause;

	// instance for sheet sprite animation
	float myCurrentCornerX;
	float myTimer; 
	float myAnimationTimer;
};
#endif