#include "App.h"
#include "InputWrapper\InputWrapper.h"
#include "Vector.h"
#include "EventSingelton.h"

DWORD WINAPI Logic( LPVOID someArg );
DWORD WINAPI Graphic( LPVOID someArg );
DWORD WINAPI Input( LPVOID someArg );

#define SCREEN_WIDTH 1024.0f
#define SCREEN_HEIGHT 768.0f


App::App( )
{
	myHGE = hgeCreate( HGE_VERSION );

	myHGE->System_SetState( HGE_TITLE, "Tha Game" );

	myHGE->System_SetState( HGE_WINDOWED, false );

	myHGE->System_SetState( HGE_USESOUND, false );

	myHGE->System_SetState(HGE_SCREENWIDTH, static_cast<int>(SCREEN_WIDTH));

	myHGE->System_SetState(HGE_SCREENHEIGHT, static_cast<int>(SCREEN_HEIGHT));

	myHGE->System_SetState(HGE_SHOWSPLASH, false);

	myHGE->System_Initiate( );

	ShowCursor(false);

	mySharedData.Initialize(myHGE, Vector2<float>( SCREEN_WIDTH, SCREEN_HEIGHT ) );

	EventSingelton::Create();

	CreateThread( 0, 0, &App::Logic, &mySharedData, 0, 0 );
	CreateThread( 0, 0, &App::Graphic, &mySharedData, 0, 0 );
	//CreateThread( 0, 0, &App::Input, &mySharedData, 0, 0 );
}

App::~App( )
{

	EventSingelton::Destroy();
 	myHGE->System_Shutdown( );
	myHGE->Release( );
}

bool App::Update( )
{
	if ( mySharedData.quitGame == true )
	{
		return false;
	}

	if( (mySharedData.threadLogicDone == true) && (mySharedData.threadGraphicDone == true))
	{				
		mySharedData.myTimerFactory.UpdateTimers();

		mySharedData.threadLogicDone = false;
		mySharedData.threadGraphicDone = false;

		int newLogicIndex = mySharedData.graphicIndex;
		int newGraphicIndex = mySharedData.logicIndex;

		mySharedData.logicIndex = newLogicIndex;
		mySharedData.graphicIndex = newGraphicIndex;

		mySharedData.threadLogicStart = true;
		mySharedData.threadGraphicStart = true;
	}

	return true;
}