#include "App.h"
#include "Timer\TimerManager.h"

#include "InputWrapper\InputWrapper.h"
#include "EventSingelton.h"


DWORD WINAPI App::Logic( LPVOID someArg )
{
	ThreadSharedData *mySharedData = static_cast<ThreadSharedData*>( someArg );

	InputWrapper inputHandler;

	inputHandler.IntializeDirectInput(mySharedData->myHGE);
	//SoundSystem::Instance().PlayMusic();
	for(;;)
	{
		if(mySharedData->quitGame == true)
		{
			Sleep( 100 );
			return 0;
		}
		else if( mySharedData->threadLogicStart == true )
		{
			//////////////////////////
			// Preparing to run thread
			//////////////////////////
			mySharedData->threadLogicStart = false;		
			int myIndex = mySharedData->logicIndex;
			float delta = mySharedData->myLogicTimer->GetDelta().GetMiliSeconds();
			mySharedData->myRenderData[myIndex].myDelta = delta;
			mySharedData->myConversationDelta += delta;

			//////////////////////////
			// Take in the input
			//////////////////////////
			inputHandler.UpdateMouse();
			mySharedData->HandleInput(inputHandler, delta);

			//////////////////////////
			// Update all the objects
			//////////////////////////
			
			if( EventSingelton::GetInstance()->myQuitMenuActive == false)
			{
				mySharedData->Update(inputHandler, delta);
				SoundSystem::Instance().Update();
			}
			else
			{
				mySharedData->Update(inputHandler, 0);
				SoundSystem::Instance().Update();
			}	

			//////////////////////////
			// Render all objects
			//////////////////////////
			mySharedData->Render(inputHandler, myIndex);
			mySharedData->myInventory.Update( Vector2<float>(static_cast<float>(inputHandler.GetMousePosition().myX), static_cast<float>(inputHandler.GetMousePosition().myY) ), mySharedData->myRenderData[myIndex]);

			mySharedData->threadLogicDone = true;
		}

		inputHandler.ResetPressedKeys();
		inputHandler.ResetClickedButtons();

		if(EventSingelton::GetInstance()->myQuitGame == true)
		{
			mySharedData->quitGame = true;
			Sleep( 100 );
			return 0;
		}

		if(mySharedData->myOutro.theGameIsOver == true)
		{
			mySharedData->quitGame = true;
			Sleep( 100 );
			return 0;
		}
		else 
		{
			Sleep(1);
		}
	}
}

DWORD WINAPI App::Graphic( LPVOID someArg )
{

	ThreadSharedData *mySharedData = static_cast<ThreadSharedData*>( someArg );
	//int timer = 0;

	for(;;)
	{
		if(mySharedData->quitGame == true)
		{
			Sleep( 100 );
			return 0;
		}
		else if( mySharedData->threadGraphicStart == true )
		{
			mySharedData->threadGraphicStart = false;

			int myIndex = mySharedData->graphicIndex;
			float delta = mySharedData->myRenderData[myIndex].myDelta;

			mySharedData->myHGE->Gfx_BeginScene( );
			mySharedData->myHGE->Gfx_Clear( 0 );		

			std::vector<RenderMessage>::iterator messageIterator = mySharedData->myRenderData[myIndex].myMessages.begin();
			std::vector<StaticSprite*>::iterator spriteIterator = mySharedData->myRenderData[myIndex].mySprites.begin();
			std::vector<AnimationBase*>::iterator animationIterator = mySharedData->myRenderData[myIndex].myAnimations.begin();
			std::vector<Font*>::iterator fontIterator = mySharedData->myRenderData[myIndex].myFont.begin();

			int thingsToRender =  mySharedData->myRenderData[myIndex].myMessages.size();
			for ( int thingRended = 0; thingRended < thingsToRender; thingRended++ )
			{
				if ( messageIterator->myType == spriteRenderMessageType )
				{
					(*spriteIterator)->RenderAtPosition(messageIterator->myPosition);
					spriteIterator++;
				}
				else if ( messageIterator->myType == animationRenderMessageType )
				{
					(*animationIterator)->RenderAtPosition(delta,messageIterator->myPosition);
					animationIterator++;
				}
				else if ( messageIterator->myType == fontRenderMessageType )
				{
					(*fontIterator)->Render();
					fontIterator++;
				}
				else
				{
					//int i = 1;
				}
				messageIterator++;
			}

			mySharedData->myRenderData[myIndex].myMessages.clear();
			mySharedData->myRenderData[myIndex].mySprites.clear();
			mySharedData->myRenderData[myIndex].myAnimations.clear();
			mySharedData->myRenderData[myIndex].myFont.clear();

			//mySharedData->myMouseCursor.Render( 0 );

			mySharedData->myHGE->Gfx_EndScene();

			mySharedData->threadGraphicDone = true;
		}
		else 
		{
			Sleep(1);
		}
	}
}

//DWORD WINAPI App::Input( LPVOID someArg )
//{
//
//	ThreadSharedData *mySharedData = static_cast<ThreadSharedData*>( someArg );
//	//int myGrowingNumber = 0;
//	//float delta = mySharedData->myLogicTimer->GetDelta().GetMiliSeconds();
//
//	//InputWrapper inputHandler;
//
//	//inputHandler.IntializeDirectInput(mySharedData->myHGE);
//
//	for(;;)
//	{
//		//int myIndex = mySharedData->logicIndex;
//		//
//		//delta = mySharedData->myInGameTimer->GetDelta( ).GetMiliSeconds( );
//
//		////////////////////
//		//inputHandler.UpdateMouse();
//		//////////////////
//
//		//int mapWidth = mySharedData->myFloor[0].GetSpriteWidth();
//		//int mapHeight = mySharedData->myFloor[0].GetSpriteHeight();
//		////float movementSpeed = 0.5f * delta;
//		//if(mySharedData->myConversation.GetConversationActive() == false && mySharedData->myInventory.myIsBeingCalled == false )
//		//{
//		//	mySharedData->myAvatar.Input(inputHandler, mySharedData->myCamera, mySharedData->myMap);
//		//}	
//
//		//if(mySharedData->myConversation.GetConversationActive() == true)
//		//{
//		//	mySharedData->myConversation.Input(inputHandler, delta);
//		//}
//		//mySharedData->myInventory.myCalledDelta += delta;
//		//if(inputHandler.KeyPressed(DIK_I))
//		//{
//		///*if( inputHandler.KeyDown( DIK_I ) )
//		//{
//		//	if(mySharedData->myInventory.myCalledDelta > 100.0f)
//		//	{*/
//		//		if(mySharedData->myInventory.myIsBeingCalled == false)
//		//		{
//		//			mySharedData->myInventory.myIsBeingCalled = true;
//		//			mySharedData->myInventory.myCalledDelta = 0;
//		//		}
//		//		else
//		//		{
//		//			mySharedData->myInventory.myIsBeingCalled = false;
//		//			mySharedData->myInventory.myCalledDelta = 0;
//		//		}
//		//	//}
//		//}		
//
//		/*mySharedData->myConversationDelta += delta;
//		if(inputHandler.KeyDown(DIK_E))
//		{
//
//			mySharedData->myAvatar.Input(inputHandler, mySharedData->myCamera.myPosition, mySharedData->myMap);
//		}	
//		if(mySharedData->myConversationDelta > 100.0f)
//		{
//		if(mySharedData->myAvatar.isinside == true)
//		{
//		if(mySharedData->myConversation.GetConversationActive() == false)
//		{
//
//		mySharedData->myConversationDelta = 0;
//		mySharedData->myConversation.ActivateConversation();
//		}
//		else
//		{
//		if(mySharedData->myConversation.GetMenuComponent().GetHighlightedItem() == 2)
//		{
//		if(mySharedData->myRobot.GetActive() == false)
//		{
//		mySharedData->myRobot.MakeActive();
//		}
//		
//		if( inputHandlerKeyPressed( DIK_I ) )
//		{
//			mySharedData->myInventory.MakeActive( );
//		}
//
//		/*mySharedData->myConversationDelta += delta;
//		if(inputHandler.KeyDown(DIK_E))
//		{
//			if(mySharedData->myConversationDelta > 100.0f)
//			{
//				if(mySharedData->myAvatar.isinside == true)
//				{
//					if(mySharedData->myConversation.GetConversationActive() == false)
//					{
//					
//						mySharedData->myConversationDelta = 0;
//						mySharedData->myConversation.ActivateConversation();
//					}
//					else
//					{
//						if(mySharedData->myConversation.GetMenuComponent().GetHighlightedItem() == 2)
//						{
//							if(mySharedData->myRobot.GetActive() == false)
//							{
//								mySharedData->myRobot.MakeActive();
//							}
//						}
//						mySharedData->myConversationDelta = 0;
//						mySharedData->myConversation.DiactivateConversation();
//					}
//				}
//			}*/
//			/*for( unsigned i = 0; i < mySharedData->myItems.size( ); i++ )
//			{
//				if( mySharedData->myItems[i].myInterractable == true )
//				{
//					mySharedData->myInventory.myItems.push_back( mySharedData->myItems[i] );
//					mySharedData->myItems.erase( mySharedData->myItems.begin( ) + i );
//				}
//			}*/
//	/*	}
//		}
//		}*/
//
//		/*if( inputHandler.KeyDown( DIK_Q ) )		{
//		for( int i = mySharedData->myItems.size( ) - 1; i > -1; i-- )
//		{
//		mySharedData->myInventory.myItems.push_back( mySharedData->myItems[i] );
//		mySharedData->myItems.erase( mySharedData->myItems.begin( ) + i );
//		}*/
//		/*}*/
//
//
//		//////////////////////////////////////
//
//		//mySharedData->myMouseCursor.SetPosition(static_cast<float>(inputHandler.GetMousePosition().myX), static_cast<float>(inputHandler.GetMousePosition().myY));
//
//		////////////////////////////////////////
//
//
//		//if ( mySharedData->myCamera.myPosition.x < 0 ) 
//		//{
//		//	mySharedData->myCamera.myPosition.x = 0;
//		//}
//		//if ( mySharedData->myCamera.myPosition.y < 0 ) 
//		//{
//		//	mySharedData->myCamera.myPosition.y = 0;
//		//}
//		//if ( (mySharedData->myCamera.myPosition.x+1024) > mapWidth ) 
//		//{
//		//	mySharedData->myCamera.myPosition.x = mapWidth-1024;
//		//}
//		//if ( (mySharedData->myCamera.myPosition.y+768) > mapHeight ) 
//		//{
//		//	mySharedData->myCamera.myPosition.y = mapHeight-768;
//		//}
//
//		int i = 0;
//		if(i == 3)
//		{
//			mySharedData->quitGame = true;
//			Sleep( 100 );
//			return 0;
//		}
//
//		Sleep(1);
//	}
//}

int GetConversationIndex(ThreadSharedData *mySharedData, std::string aID)
{
	int confirmedID = 0;
	for(unsigned int index = 0; index < mySharedData->myActiveLevel->myConversationList.size(); index++)
	{
		if(mySharedData->myActiveLevel->myConversationList[index].myConversationID == aID)
		{
			confirmedID = index;
		}
	}
	return confirmedID;
}

int GetItemIndex(ThreadSharedData *mySharedData, std::string aID)
{
	int confirmedID = 0;
	for(unsigned int index = 0; index < mySharedData->myActiveLevel->myItems.size(); index++)
	{
		if(mySharedData->myActiveLevel->myItems[index].myID == aID)
		{
			confirmedID = index;
		}
	}
	return confirmedID;
}