#include "BlownUpCave.h"

BlownUpCave::BlownUpCave(void)
:LevelBaseData()
{
}

BlownUpCave::BlownUpCave(const LevelBaseData& aLevelBaseData)
:LevelBaseData(aLevelBaseData)
{

}

BlownUpCave::~BlownUpCave(void)
{
}

void BlownUpCave::Initialize(HGE *aHGE)
{
	myHge = aHGE;

	StaticSprite tempSprite = StaticSprite(myHge, "img/Levels/scene_cave_blown_up.dds");
	myMap.AddFloorSprite(tempSprite, Vector2<float>(0, 0));
	tempSprite = StaticSprite(myHge, "img/Levels/scene_caves_overlay.dds");
	myMap.AddOverlaySprite(tempSprite, Vector2<float>(0, 0));
	myCollisionMap = CollisionMap(16, "img/Levels/collision_cave.bmp", myHge);

	myRobot = Robot(myHge);
	myRobot.Initialize();
	myRobot.SetWorldSpacePosition( Vector2<float>( -10000.0f, -10000.0f ) );

	myThisLevelMusic = "Vulcano";

	InitializeConversations();

	myConversationDeltaForOnlyConversation = 0.0f;

	myEndOfGame = false;
}

void BlownUpCave::LevelSpecificHandleInput(InputWrapper &aInputWrapper, float aDelta, Inventory &aInventory)
{
	aDelta;
	aInventory;

	if((aInputWrapper.KeyPressed(DIK_E)) || (aInputWrapper.KeyPressed(DIK_RETURN)))
	{
		if(myDoneConversation.at(GetConversationIndex("Activate Roderick")) == false)
		{
			myRobot.MakeActive();
		}
	}
}

void BlownUpCave::LevelSpecificUpdate(Avatar &aAvatar, Camera &aCamera, float aDelta)
{
	Vector2<float> tempVector = aAvatar.GetWorldSpacePosition();
	//myRobot.ChaseAvatar( (aAvatar.GetWorldSpacePosition()), aDelta);
	myRobot.Update(aDelta, aCamera.myPosition, tempVector );
}

void BlownUpCave::LevelSpecificRender(RenderData &aRenderData, Camera &aCamera)
{
	aCamera;
	myRobot.Render(aRenderData);
}

void BlownUpCave::InitializeConversations()
{
	myConversationList.reserve(101);
	myConversationList.push_back(LevelConversation(myHge, "NONE", false));
	myConversationList.push_back(LevelConversation(myHge, "blown apart", false));

	for(unsigned int index = 0; index < myConversationList.size(); index++)
	{
		myConversationList[index].Initialize();
		myConversationList[index].myActiveConversation = false;
		myDoneConversation.set(index);
	}

	myConversationList[GetConversationIndex("blown apart")].myDialoge.SetLeftPortrait("img/Conversation/heroinePortrait.dds", "Esther");
	myConversationList[GetConversationIndex("blown apart")].myDialoge.SetRightPortrait("img/empty.dds", " ");
	myConversationList[GetConversationIndex("blown apart")].AddDialogeText("Esther: : Man... That blast really made a dent into the cave wall where we got the magnetic rock.;");
	myConversationList[GetConversationIndex("blown apart")].AddDialogeText("Esther: : Hope that wont affect the future in any scary way...;");

	myActiveConversationID = "";
	myActiveConversationIndex = 0;
}

void BlownUpCave::ConversationEvent(float elapsTime, Avatar &aAvatar, Inventory &aInventory)
{
	aInventory;

	aAvatar;
	myConversationDelta += elapsTime;

	if( myDoneConversation.at( GetConversationIndex("blown apart") ) == true )
	{
		myConversationDeltaForOnlyConversation += elapsTime;

		if( myConversationDeltaForOnlyConversation > 2000.0f )
		{
			myActiveConversationID = "blown apart";
		}
	}

}