#pragma once

#include "HGE\hge.h"
#include "HGE\hgeSprite.h"
#include <string>
#include "Vector.h"

class CollisionMap
{
public:
	CollisionMap();
	CollisionMap(int aPixTileSize, std::string aCollisionCollisionMapFileName, HGE* aHge);
	CollisionMap(const CollisionMap &aCollisionMap);
	~CollisionMap();

	bool CheckIfPassable(Vector2<float> aCollisionMapPosition);
	Vector2<float> GetDimensions();

private:
	int ConvertToIndex(Vector2<float> aCollisionMapPosition);

	Vector2<float> myDimensions;
	bool myInitiated;
	int myPixTileSize;
	int myPixWidth;
	HTEXTURE myCollisionTexture;
	HGE* myHGE;

};
