#ifndef ___CONSOLE_H___
#define ___CONSOLE_H___

#include "RenderInformation.h"
#include "Vector.h"
#include "InputWrapper/InputWrapper.h"


class Console
{
public:
	Console();
	Console(HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition);
	Console(HGE* aHGE);
	~Console();

	bool IsAvatarInProximity(Vector2<float>& anAvatarPosition);
	
	void InputHandling(InputWrapper& aInput);
	void Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition);
	void Render(RenderData &someRenderData);

	
	bool IsInterractable();
	void MakeInterractable();
	void MakeNotInterractable();

	void SwitchState();
	void MakeActive();
	void MakeNotActive();
	bool IsActive();

	Vector2<float> myWorldSpacePosition;
	Vector2<float> myCameraSpacePosition;


private:

	HGE* myHGE;

	StaticSprite mySprite;
	StaticSprite myInterractionButton;
	
	bool myAvatarNear;
	bool myIsBeingCalled;
};

#endif