#include "Conversation.h"

Conversation::Conversation()
{
}
Conversation::Conversation(HGE *aHge):
myHge(aHge)
{
	myBoxSpriteList.Init(5, 5);
	myFontSpriteList.Init(5, 5);
	myActiveConversation = false;
	myMenuComponent = new MenuComponent(aHge);
}

Conversation::Conversation(const Conversation &aConversation):
myHge(aConversation.myHge)
{
	myBoxSpriteList = aConversation.myBoxSpriteList;
	myFontSpriteList = aConversation.myFontSpriteList;
	myActiveConversation = aConversation.myActiveConversation;
	myMenuComponent = aConversation.myMenuComponent;
}
Conversation::~Conversation()
{

}

void Conversation::Initialize()
{
	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/ConversationBox.dds"));
	myBoxSpriteList[BOX_BACKGROUND].SetPosition(0.0f, 430.0f);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/heroinePortrait.dds"));
	myBoxSpriteList[BOX_LEFT_PORTRAIT].SetPosition(5.0f, myBoxSpriteList[BOX_BACKGROUND].GetPosition().y - 6);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/NameBox.dds"));
	myBoxSpriteList[BOX_LEFT_NAME_PLATE].SetPosition(myBoxSpriteList[BOX_LEFT_PORTRAIT].GetPosition().x, myBoxSpriteList[BOX_LEFT_PORTRAIT].GetPosition().y + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteHeight() + 10.0f);
	
	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/RobotPortrait.dds"));
	myBoxSpriteList[BOX_RIGHT_PORTRAIT].SetPosition(myHge->System_GetState(HGE_SCREENWIDTH) - myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetSpriteWidth() - 5.0f, myBoxSpriteList[BOX_BACKGROUND].GetPosition().y - 6);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/NameBox.dds"));
	myBoxSpriteList[BOX_RIGHT_NAME_PLATE].SetPosition(myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetPosition().x, myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetPosition().y + myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetSpriteHeight() + 10.0f);

	myTextRec = new hgeRect(
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15, 
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().y + 35,
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15 + 482, 
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().y + 35 + 186);	
	

	myFontSpriteList.Add(Font(myHge, "Heroine bobhead"));
	myFontSpriteList[TEXT_PORTRAIT_LEFT_NAME].SetPosition(myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetPosition().x + myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetSpriteWidth() / 2, myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetPosition().y + 17);
	myFontSpriteList[TEXT_PORTRAIT_LEFT_NAME].SetTextAlign(2);

	myFontSpriteList.Add(Font(myHge, "Roderick robot"));
	myFontSpriteList[TEXT_PORTRAIT_RIGHT_NAME].SetPosition(myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetPosition().x + myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetSpriteWidth() / 2, myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetPosition().y + 17);
	myFontSpriteList[TEXT_PORTRAIT_RIGHT_NAME].SetTextAlign(2);

	myFontSpriteList.Add(Font(myHge, "Bzzz...\n"));
	myFontSpriteList[TEXT_BOX_TEXT].SetPosition(myTextRec->x1, myTextRec->y1);
	myFontSpriteList[TEXT_BOX_TEXT].SetTextAlign(0);

	for(int index = 0; index < 3; index++)
	{
		myFontSpriteList[index].SetSpriteFont("img/Font/candl.fnt");
		myFontSpriteList[index].Initialize();
	}

	myMenuComponent->AddMenuItem("Hello.");
	myMenuComponent->AddMenuItem("Hi.");
	myMenuComponent->AddMenuItem("Activate Robot AI.");
	myMenuComponent->SetPosition(myFontSpriteList[TEXT_BOX_TEXT].GetPosition().x, (myFontSpriteList[TEXT_BOX_TEXT].GetPosition().y + (myFontSpriteList[TEXT_BOX_TEXT].GetFontHeight() * 2) + 5));
	myMenuComponent->SetHighlightedColour(255, 255, 255, 0);
	myMenuComponent->SetNormalColour(255, 0, 206, 209);
	myMenuComponent->Initialize();
}
void Conversation::Input(InputWrapper& aInput, float aInputElapsTime)
{
	myMenuComponent->Input(aInput, aInputElapsTime);
}
void Conversation::Update(float aElapseTime)
{
	myMenuComponent->Update(aElapseTime);
}
void Conversation::Render(float aElapseTime)
{
	aElapseTime = aElapseTime;
}

void Conversation::ActivateConversation()
{
	myActiveConversation = true;
}
void Conversation::DiactivateConversation()
{
	myActiveConversation = false;
}
bool Conversation::GetConversationActive()
{
	return myActiveConversation;
}

StaticSprite* Conversation::GetStaticSpriteRef(int index)
{
	return &myBoxSpriteList[index];
}
Font* Conversation::GetFontRef(int index)
{
	return &myFontSpriteList[index];
}
MenuComponent& Conversation::GetMenuComponent()
{
	return *myMenuComponent;
}