#ifndef _CONVERSATION_H_
#define _CONVERSATION_H_
#include "HGE\hge.h"
#include "HGE\hgerect.h"
#include "StaticSprite.h"
#include "Font.h"
#include "MenuComponent.h"
#include "Arrays\GrowingArray.h"
#include "InputWrapper\InputWrapper.h"

#include <string>

//struct ConversationMenu
//{
//	Font* myItem;
//	bool myItemIsHightlight;
//};
class Conversation
{
public:
	Conversation();
	Conversation(HGE* aHge);
	Conversation(const Conversation& aConversation);
	~Conversation();

	void Initialize();
	void Input(InputWrapper& aInput, float aInputElapsTime);
	void Update(float aElapseTime);
	void Render(float aElapseTime);

	void SetRightPortrait(std::string aRightPortrait);
	void SetLeftPortrait(std::string aLeftPortrait);

	void ActivateConversation();
	void DiactivateConversation();
	bool GetConversationActive();

	StaticSprite* GetStaticSpriteRef(int index);
	Font* GetFontRef(int index);
	MenuComponent& GetMenuComponent();

private:
	enum BoxIndex
	{
		BOX_BACKGROUND,
		BOX_LEFT_PORTRAIT,
		BOX_LEFT_NAME_PLATE,
		BOX_RIGHT_PORTRAIT,
		BOX_RIGHT_NAME_PLATE
	};
	enum FontIndex
	{
		TEXT_PORTRAIT_LEFT_NAME,
		TEXT_PORTRAIT_RIGHT_NAME,
		TEXT_BOX_TEXT
	};

	HGE* myHge;
	HTEXTURE myTexture;
	hgeRect* myTextRec;


	Tools::GrowingArray<StaticSprite, int> myBoxSpriteList;
	Tools::GrowingArray<Font, int> myFontSpriteList;

	MenuComponent* myMenuComponent;
	bool myActiveConversation;	
};
#endif