#ifndef ___CONVERSATION_HOT_SPOT_H___
#define ___CONVERSATION_HOT_SPOT_H___


#include "Vector.h"


#include <string>


class ConversationHotSpot
{

public:

	ConversationHotSpot( const ConversationHotSpot &aConversationHotSpot )
	{

		myBoxSpot = aConversationHotSpot.myBoxSpot;
		myHeight = aConversationHotSpot.myHeight;
		myWidth = aConversationHotSpot.myWidth;
		myID = aConversationHotSpot.myID;

	}

	ConversationHotSpot( Vector2<float> aPosition, float aWidth, float aHeight, std::string anID )
	{

		myBoxSpot.myX = aPosition.myX;
		myBoxSpot.myY = aPosition.myY;
		myBoxSpot.myZ = aPosition.myX + aWidth;
		myBoxSpot.myW = aPosition.myY + aHeight;

		myHeight = aHeight;
		myWidth = aWidth;

		myID = anID;

	}

	~ConversationHotSpot( )
	{
	}

	bool IsAvatarInsideMe( Vector2<float> &aPosition )
	{
		if( aPosition.myX < myBoxSpot.myX )
		{
			return false;
		}
		if( aPosition.myY < myBoxSpot.myY )
		{
			return false;
		}
		if( aPosition.myX > myBoxSpot.myZ )
		{
			return false;
		}
		if( aPosition.myY > myBoxSpot.myW )
		{
			return false;
		}

		return true;

	}

	std::string GetHotSpotID( )
	{
		return myID;
	}

private:

	std::string myID;

	float myHeight;
	float myWidth;

	ConversationHotSpot( )
	{

	}

	Vector4<float> myBoxSpot;

};


#endif