#ifndef ___CURSOR_H___
#define ___CURSOR_H___


#include "StaticSprite.h"
#include "RenderInformation.h"
#include "EventSingelton.h"

#include <string>


class Cursor
{

public:

	Cursor( )
	{
		mySprite = 0;
	}

	Cursor( const Cursor &aCursor )
	{
		mySprite = aCursor.mySprite;
		myPosition = aCursor.myPosition;
	}

	Cursor( HGE *aHGE, std::string aFileName )
	{
		mySprite = StaticSprite( aHGE, aFileName );
	}

	~Cursor( )
	{
	}

	void Update( Vector2<long> aMousePosition )
	{
		myPosition.myX = static_cast<float>( aMousePosition.myX );
		myPosition.myY = static_cast<float>( aMousePosition.myY );
	}

	void Render( RenderData &someRenderInformation, bool aIsInventoryActive )
	{
		if( aIsInventoryActive == true || EventSingelton::GetInstance()->myQuitMenuActive == true )
		{
			RenderMessage tempRenderMessage;
			tempRenderMessage.myPosition = myPosition;
			tempRenderMessage.myType = spriteRenderMessageType;
			someRenderInformation.myMessages.push_back( tempRenderMessage );
			someRenderInformation.mySprites.push_back( &mySprite );
		}
	}

	Vector2<float> myPosition;

	StaticSprite mySprite;

private:

};

#endif