#ifndef _CURTAIN_H_
#define _CURTAIN_H_
#include "Vector.h"
#include "StaticSprite.h"

class Curtain
{
public:
	Curtain(){}
	Curtain( HGE *aHGE )
	{
		myPosition = Vector2<float>( 0.0f, 0.0f );
		myColor = Vector4<int>( 255, 255, 255, 255 );
		mySprite = StaticSprite( aHGE, "img/curtain.png" );
		mySprite.SetPosition( myPosition );
		myIsFading = false;
	}
	~Curtain(){}

	void FadeIn()
	{
		myIsFading = true;
		myColor.a -= 1;
		if(myColor.a <= 0)
		{
			myColor.a = 0;
			myIsFading = false;
		}
		mySprite.SetColor(myColor);
	}
	void SetCutsceenTexture(HTEXTURE aTexture)
	{
		mySprite.SetTexture(aTexture);
	}
	void FadeTextureIn()
	{
		myIsFading = true;
		myColor.a -= 1;
		if(myColor.a <= 0)
		{
			myColor.a = 0;
			myIsFading = false;
		}
		mySprite.SetColor(myColor);
	}
	void FadeOut()
	{
		myIsFading = true;
		myColor.a += 1;
		if(myColor.a >= 255)
		{
			myColor.a = 255;
			myIsFading = false;
		}
		mySprite.SetColor(myColor);
	}

	void Update()
	{
		
	}
	void Render( RenderData &someRenderData )
	{
		RenderMessage tempMessage;

		tempMessage.myPosition = myPosition;
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back(tempMessage);
		someRenderData.mySprites.push_back(&mySprite);
	}

	bool myIsFading;
private:
	StaticSprite mySprite;
	Vector2<float> myPosition;
	Vector4<int> myColor;
};
#endif