#include "Dialogue.h"
#include "EventSingelton.h"

Dialogue::Dialogue()
{
}
Dialogue::Dialogue(HGE *aHge):
myHge(aHge)
{
	myBoxSpriteList.Init(5, 5);
	myFontSpriteList.Init(5, 5);
	//myDialogeList.Init(5, 5);
	
	myActiveConversation = true;
	//myMenuComponent = new MenuComponent(aHge);
	theInputElapseTime = 0.0f;
	myCurrentDialogeLine = 0;

}

Dialogue::Dialogue(const Dialogue &aDialogue):
myHge(aDialogue.myHge)
{
	myBoxSpriteList = aDialogue.myBoxSpriteList;
	myFontSpriteList = aDialogue.myFontSpriteList;
	myDialogeList = aDialogue.myDialogeList;
	myActiveConversation = aDialogue.myActiveConversation;
	theInputElapseTime = aDialogue.theInputElapseTime;
	myCurrentDialogeLine = aDialogue.myCurrentDialogeLine;
}
Dialogue::~Dialogue()
{

}

void Dialogue::Initialize()
{
	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/ConversationBox.dds"));
	myBoxSpriteList[BOX_BACKGROUND].SetPosition(0.0f, 430.0f);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/EmptyPortrait.dds"));
	myBoxSpriteList[BOX_LEFT_PORTRAIT].SetPosition(5.0f, myBoxSpriteList[BOX_BACKGROUND].GetPosition().y - 6);
	myBoxSpriteList[BOX_LEFT_PORTRAIT].SetVisible(false);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/NameBox.dds"));
	myBoxSpriteList[BOX_LEFT_NAME_PLATE].SetPosition(myBoxSpriteList[BOX_LEFT_PORTRAIT].GetPosition().x, myBoxSpriteList[BOX_LEFT_PORTRAIT].GetPosition().y + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteHeight() + 10.0f);
	myBoxSpriteList[BOX_LEFT_NAME_PLATE].SetVisible(false);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/EmptyPortrait.dds"));
	myBoxSpriteList[BOX_RIGHT_PORTRAIT].SetPosition(myHge->System_GetState(HGE_SCREENWIDTH) - myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetSpriteWidth() - 5.0f, myBoxSpriteList[BOX_BACKGROUND].GetPosition().y - 6);
	myBoxSpriteList[BOX_RIGHT_PORTRAIT].SetVisible(false);

	myBoxSpriteList.Add(StaticSprite(myHge, "img/Conversation/NameBox.dds"));
	myBoxSpriteList[BOX_RIGHT_NAME_PLATE].SetPosition(myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetPosition().x, myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetPosition().y + myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetSpriteHeight() + 10.0f);
	myBoxSpriteList[BOX_RIGHT_NAME_PLATE].SetVisible(false);
	myTextRec = new hgeRect(
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15, 
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().y + 35,
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15 + 482, 
		myBoxSpriteList[BOX_BACKGROUND].GetPosition().y + 35 + 186);	
	
	myRectLenght = 0.0f;

	myFontSpriteList.Add(Font(myHge, ""));
	myFontSpriteList[TEXT_PORTRAIT_LEFT_NAME].SetPosition(myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetPosition().x + myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetSpriteWidth() / 2, myBoxSpriteList[BOX_LEFT_NAME_PLATE].GetPosition().y + 15);
	myFontSpriteList[TEXT_PORTRAIT_LEFT_NAME].SetTextAlign(2);

	myFontSpriteList.Add(Font(myHge, ""));
	myFontSpriteList[TEXT_PORTRAIT_RIGHT_NAME].SetPosition(myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetPosition().x + myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetSpriteWidth() / 2, myBoxSpriteList[BOX_RIGHT_NAME_PLATE].GetPosition().y + 15);
	myFontSpriteList[TEXT_PORTRAIT_RIGHT_NAME].SetTextAlign(2);

	myFontSpriteList.Add(Font(myHge, ""));
	myFontSpriteList[TEXT_BOX_TEXT].SetPosition(myTextRec->x1, myTextRec->y1);
	myFontSpriteList[TEXT_BOX_TEXT].SetTextAlign(0);

	for(int index = 0; index < 3; index++)
	{
		myFontSpriteList[index].SetSpriteFont("img/Font/HGE_font1.fnt");
		myFontSpriteList[index].Initialize();
	}
}
void Dialogue::Input(InputWrapper& aInput)
{
	if( aInput.KeyPressed( DIK_RETURN )
		&& EventSingelton::GetInstance()->myQuitMenuActive == false )
	{
		if(myCurrentDialogeLine != myDialogeList.size())
		{
			myCurrentDialogeLine++;
		}

		if(myCurrentDialogeLine >= myDialogeList.size())
		{
			myActiveConversation = false;
		}
			
	}	
}
void Dialogue::Update()
{
	if(myActiveConversation != false)
	{
		myFontSpriteList[TEXT_BOX_TEXT].SetText(myDialogeList[myCurrentDialogeLine]);
	}
}
void Dialogue::Render(RenderData &someRenderData)
{
	RenderMessage tempMessage;
	for(signed int index = 0; index < myBoxSpriteList.Count(); index++)
	{
		tempMessage.myPosition = myBoxSpriteList[index].GetPosition();
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myBoxSpriteList[index] );
	}
	for(signed int index = 0; index < myFontSpriteList.Count(); index++)
	{
		tempMessage.myPosition = myFontSpriteList[index].GetPosition();
		tempMessage.myType = fontRenderMessageType;
		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.myFont.push_back( &myFontSpriteList[index] );
	}
}

void Dialogue::SetLeftPortrait(std::string aLeftPortrait, std::string aName)
{
	HTEXTURE leftPortrait = myHge->Texture_Load(aLeftPortrait.c_str());
	myBoxSpriteList[BOX_LEFT_PORTRAIT].SetTexture(leftPortrait);
	myBoxSpriteList[BOX_LEFT_PORTRAIT].SetVisible(true);
	myBoxSpriteList[BOX_LEFT_NAME_PLATE].SetVisible(true);
	myFontSpriteList[TEXT_PORTRAIT_LEFT_NAME].SetText(aName.c_str());
	myTextRec->x2 = myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15 + 482 + myBoxSpriteList[BOX_RIGHT_PORTRAIT].GetSpriteWidth() - 15;	
	myRectLenght = myTextRec->x2 - myTextRec->x1;
}
void Dialogue::SetRightPortrait(std::string aRightPortrait, std::string aName)
{
	HTEXTURE portrait = myHge->Texture_Load(aRightPortrait.c_str());
	myBoxSpriteList[BOX_RIGHT_PORTRAIT].SetTexture(portrait);
	myBoxSpriteList[BOX_RIGHT_PORTRAIT].SetVisible(true);
	myBoxSpriteList[BOX_RIGHT_NAME_PLATE].SetVisible(true);
	myFontSpriteList[TEXT_PORTRAIT_RIGHT_NAME].SetText(aName.c_str());
	myTextRec->x2 = myBoxSpriteList[BOX_BACKGROUND].GetPosition().x + myBoxSpriteList[BOX_LEFT_PORTRAIT].GetSpriteWidth() + 15 + 482;
	myRectLenght = myTextRec->x2 - myTextRec->x1;
}
void Dialogue::AddConversationText(std::string aText)
{
	//1. tanka ner alla ord som finns i strngen
	std::vector<std::string> stringVec;
	std::string tempWord = "";
	for(unsigned int loop = 0; loop < aText.length(); loop++)
	{
		if(aText[loop] != ' ' && aText[loop] != ';')
		{
			tempWord += aText[loop];
		}
		if(aText[loop] == ' ' || aText[loop] == ';')
		{
			stringVec.push_back(tempWord);
			tempWord = "";
		}
	}

	//2. test till vid addering av ordet i vektor blir lngre n textboxens lngd.
	hgeFont tempFont("img/Font/HGE_font1.fnt");
	std::string tempLine = "";
	std::string addLine = "";
	float textLenght = 0.0f;
	for(unsigned int index = 0; index < stringVec.size(); index++)
	{
		if(stringVec[index] != ":")
		{
			textLenght = tempFont.GetStringWidth(tempLine.c_str());
			float wordLenght = tempFont.GetStringWidth(stringVec[index].c_str());
			textLenght += wordLenght;
			if(textLenght < myRectLenght)
			{
				tempLine += ' ' + stringVec[index];
			}
			else
			{
				tempLine += '\n';
				addLine += tempLine;
				tempLine = stringVec[index];
			}
		}
		else
		{
			tempLine += '\n';
			addLine += tempLine;
			tempLine = "";
		}
	}
	addLine += tempLine;
	//myDialogeList.Add(aText);
	myDialogeList.push_back(addLine);}

StaticSprite* Dialogue::GetStaticSpriteRef(int index)
{
	return &myBoxSpriteList[index];
}
Font* Dialogue::GetFontRef(int index)
{
	return &myFontSpriteList[index];
}

Tools::GrowingArray<StaticSprite, int> Dialogue::GetBoxSpriteList()
{
	return myBoxSpriteList;
}
Tools::GrowingArray<Font, int> Dialogue::GetFontSpriteList()
{
	return myFontSpriteList;
}