#ifndef _DIALOGUE_H_
#define _DIALOGUE_H_
#include "HGE\hge.h"
#include "HGE\hgerect.h"
#include "StaticSprite.h"
#include "Font.h"
#include "Arrays\GrowingArray.h"
#include <string>
#include <vector>
#include "MenuComponent.h"
#include "inputwrapper/inputwrapper.h"
#include "RenderInformation.h"

class Dialogue
{
public:
	Dialogue();
	Dialogue(HGE* aHge);
	Dialogue(const Dialogue& aDialogue);
	~Dialogue();

	void Initialize();
	void Input(InputWrapper& aInput);
	void Update();
	void Render(RenderData &someRenderData);

	void SetRightPortrait(std::string aRightPortrait, std::string aName);
	void SetLeftPortrait(std::string aLeftPortrait, std::string aName);
	void AddConversationText(std::string aText);

	Tools::GrowingArray<StaticSprite, int> GetBoxSpriteList();
	Tools::GrowingArray<Font, int> GetFontSpriteList();

	StaticSprite* GetStaticSpriteRef(int index);
	Font* GetFontRef(int index);

	bool myActiveConversation;	
	//MenuComponent* myMenuComponent;
	

private:
	enum BoxIndex
	{
		BOX_BACKGROUND,
		BOX_LEFT_PORTRAIT,
		BOX_LEFT_NAME_PLATE,
		BOX_RIGHT_PORTRAIT,
		BOX_RIGHT_NAME_PLATE
	};
	enum FontIndex
	{
		TEXT_PORTRAIT_LEFT_NAME,
		TEXT_PORTRAIT_RIGHT_NAME,
		TEXT_BOX_TEXT
	};

	HGE* myHge;
	HTEXTURE myTexture;
	hgeRect* myTextRec;

	Tools::GrowingArray<StaticSprite, int> myBoxSpriteList;
	Tools::GrowingArray<Font, int> myFontSpriteList;
	std::vector<std::string> myDialogeList;

	//Tools::GrowingArray<std::string, int> myDialogeList;

	unsigned int myCurrentDialogeLine;
	float theInputElapseTime;
	float myRectLenght;

};
#endif