#ifndef ___EVENT_HOT_SPOT_H___
#define ___EVENT_HOT_SPOT_H___


#include "Vector.h"


#include <string>


class EventHotSpot
{

public:

	EventHotSpot( const EventHotSpot &aEventHotSpot )
	{

		myBoxSpot = aEventHotSpot.myBoxSpot;
		myHeight = aEventHotSpot.myHeight;
		myWidth = aEventHotSpot.myWidth;
		myID = aEventHotSpot.myID;

	}

	EventHotSpot( Vector2<float> aPosition, float aWidth, float aHeight, std::string anID )
	{

		myBoxSpot.myX = aPosition.myX;
		myBoxSpot.myY = aPosition.myY;
		myBoxSpot.myZ = aPosition.myX + aWidth;
		myBoxSpot.myW = aPosition.myY + aHeight;

		myHeight = aHeight;
		myWidth = aWidth;

		myID = anID;

	}

	~EventHotSpot( )
	{
	}

	bool IsAvatarInsideMe( Vector2<float> &aPosition )
	{
		if( aPosition.myX < myBoxSpot.myX )
		{
			return false;
		}
		if( aPosition.myY < myBoxSpot.myY )
		{
			return false;
		}
		if( aPosition.myX > myBoxSpot.myZ )
		{
			return false;
		}
		if( aPosition.myY > myBoxSpot.myW )
		{
			return false;
		}

		return true;

	}

	std::string GetHotSpotID( )
	{
		return myID;
	}

private:

	std::string myID;

	float myHeight;
	float myWidth;

	EventHotSpot( )
	{

	}

	Vector4<float> myBoxSpot;

};


#endif