#include "EventSingelton.h"
#include "Macros.h"

#include <assert.h>
#include <iostream>


EventSingelton* EventSingelton::ourInstance = NULL;


EventSingelton::EventSingelton()
{
	myLogTreeActiveStatus = false;
	myRobotIsActiveFlag = false;
	myRobotIsActiveFlag = false;
	myRaftCreated = false;
	myNotebookActive = false;
	myConversationActive = false;
	myInventoryActive = false;
	myAvatarShouldAnimate = true;
	myQuitMenuActive = false;
	myQuitGame = false;
	myIntroHasPlayed = false;
}

EventSingelton::~EventSingelton()
{
}

void EventSingelton::Create()
{
	assert(ourInstance == NULL && "PostMaster has already been created");
	ourInstance = new EventSingelton();
}

void EventSingelton::Destroy()
{
	SAFE_DELETE(ourInstance);
}

EventSingelton* const EventSingelton::GetInstance()
{
	assert(ourInstance != NULL && "ourInstance has not been initialized");
	return ourInstance;
}

//bool EventSingelton::GetActiveStatus(unsigned int aFlagToGet)
//{
//	if(aFlagToGet == LOG_TREE)
//	{
//		return myLogTreeActiveStatus;
//	}
//}
//
//void EventSingelton::SetActiveStatus(unsigned int aFlagToGet, bool aValue)
//{
//	if(aFlagToGet == LOG_TREE)
//	{
//		myLogTreeActiveStatus = aValue;
//	}
//}

