#include "Font.h"
#include <assert.h>


Font::Font()
{
}

Font::Font(HGE *aHGE):
myHGE(aHGE)
{
}

Font::Font(HGE *aHGE, std::string aText):
myHGE(aHGE)
{
	myText = aText;
}

Font::Font(const Font &aFont):
myHGE(aFont.myHGE)
{
	myFont = aFont.myFont;
	mySpriteFont = aFont.mySpriteFont;
	myPosition = aFont.myPosition;
	myTextAlign = aFont.myTextAlign;
	myText = aFont.myText;
	myIsVisible = aFont.myIsVisible;
}

Font::~Font()
{
}

void Font::Initialize()
{
	myFont = new hgeFont(mySpriteFont.c_str());
	assert ( myFont && "Could not load the font.");
	myIsVisible = true;
}

void Font::Render()
{
	if(myIsVisible == true)
	{
		myFont->Render(myPosition.x, myPosition.y, myTextAlign, myText.c_str());
	}
}

void Font::SetSpriteFont(std::string aFontSprite)
{
	mySpriteFont = aFontSprite;
	assert(myHGE->Resource_EnumFiles(mySpriteFont.c_str()) && "Cannot load the font source");
}

void Font::SetPosition(Vector2<float> aPosition)
{
	myPosition = aPosition;
}

void Font::SetPosition(float aPositionX, float aPositionY)
{
	myPosition.x = aPositionX;
	myPosition.y = aPositionY;
}

void Font::SetTextAlign(int aAlign)
{
	myTextAlign = aAlign;
}

void Font::SetText(std::string aText)
{
	myText = aText;
}

void Font::SetColor(const int aAlpha, const int aRed, const int aGreen, const int aBlue)
{
	myFont->SetColor(ARGB(aAlpha, aRed, aGreen, aBlue));
}

void Font::SetColor(const Vector4<int> aColour)
{
	myFont->SetColor(ARGB(aColour.a, aColour.r, aColour.g, aColour.b)); 
}

void Font::SetVisible(bool aIsVisible)
{
	myIsVisible = aIsVisible;
}

Vector2<float> Font::GetPosition()
{
	return myPosition;
}

float Font::GetFontHeight()
{
	return myFont->GetHeight();
}