#ifndef _FONT_H_
#define _FONT_H_
#include "HGE\hge.h"
#include "HGE\hgeFont.h"
#include <string>
#include "Vector.h"


class Font
{
public:
	enum TextAlign
	{
		TEXT_LEFT,
		TEXT_CENTER,
		TEXT_RIGHT
	};
	Font();
	Font(HGE* aHGE);
	Font(HGE* aHGE, std::string aText);
	Font(const Font& aFont);
	~Font();

	void SetSpriteFont(std::string aFontSprite);
	void SetPosition(Vector2<float> aPosition);
	void SetPosition(float aPositionX, float aPositionY);
	void SetText(std::string aText);
	void SetTextAlign(int aAlign);
	void SetColor(const int aAlpha, const int aRed, const int aGreen, const int aBlue);
	void SetColor(const Vector4<int> aColour);
	void SetVisible(bool aIsVisible);

	Vector2<float> GetPosition();
	float GetFontHeight();
	void Initialize();
	void Render();
private:
	HGE* myHGE;
	hgeFont *myFont;

	std::string mySpriteFont;
	Vector2<float> myPosition;
	std::string myText;
	int myTextAlign;

	bool myIsVisible;
};
#endif