#include "Intro.h"
#include "EventSingelton.h"

Intro::Intro()
{
}
Intro::Intro(HGE *aHGE):
myHGE(aHGE)
{
	mySprite = StaticSprite(aHGE, "img/CutsceneImages/prologue01.dds");

	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue02.dds"));
	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue03.dds"));
	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue04.dds"));
	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue05.dds"));
	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue06.dds"));
	myScenes.push_back(aHGE->Texture_Load("img/CutsceneImages/prologue07.dds"));

	myIntroIsPlaying = true;
	myIntroHasPlayed = false;
	myTimer = 0.0f;
	myNextSceen = false;
	myCurrentScreen = 0;
	myPosition = Vector2<float>(0.0f, 0.0f);
}
Intro::Intro(const Intro &aIntro):
myHGE(aIntro.myHGE)
{
	myScenes = aIntro.myScenes;
	myIntroIsPlaying = aIntro.myIntroIsPlaying;
	myIntroHasPlayed = aIntro.myIntroHasPlayed;
	myTimer = aIntro.myTimer;
	myNextSceen = aIntro.myNextSceen;
}
Intro::~Intro()
{
}

void Intro::PlayIntro(float aElapseTime)
{
	myTimer += aElapseTime;
	if( (myTimer >= 5000 || myNextSceen == true) )
	{
		if(myCurrentScreen < myScenes.size())
		{
			mySprite.SetTexture(myScenes[myCurrentScreen]);
		}
		else
		{
			myIntroIsPlaying = false;
			myIntroHasPlayed = true;
			EventSingelton::GetInstance()->myIntroHasPlayed = true;
		}
		myTimer = 0.0f;
		myNextSceen = false;
		myCurrentScreen++;
	}

}
void Intro::Input(InputWrapper &aInputWrapper)
{
	if(myIntroIsPlaying == true)
	{
		if(aInputWrapper.KeyPressed(DIK_E) || aInputWrapper.KeyPressed(DIK_RETURN))
		{
			myNextSceen = true;
		}
	}
}
void Intro::Render(RenderData &someRenderData)
{
	if(myIntroHasPlayed == false)
	{
		RenderMessage tempMessage;

		tempMessage.myPosition = myPosition;
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back(tempMessage);
		someRenderData.mySprites.push_back(&mySprite);
	}
}