#ifndef ___INVENTORY_H___
#define ___INVENTORY_H___


#include <vector>


#include "InputWrapper/InputWrapper.h"
#include "Vector2.h"
#include "RenderInformation.h"
#include "AnimationBase.h"
#include "Combine.h"
#include "Font.h"
#include "EventSingelton.h"

class Inventory
{

public:

	Inventory( )
	{

	}

	Inventory( HGE *aHGE )
	{

		mySprite = StaticSprite( aHGE, "img/Inventory-Notepad/inventory.dds" );
		myPosition.myX = 200;
		myPosition.myY = 50;
		mySprite.SetPosition(myPosition);
		
		myGlow = StaticSprite(aHGE, "img/Inventory-Notepad/inventory_highlight_buttonnew.dds");

		myCombineSuccess = StaticSprite(aHGE, "img/Inventory-Notepad/combination_successful.dds");
		myCombineFailure = StaticSprite(aHGE, "img/Inventory-Notepad/combination_failed.dds");

		myForItemData.push_back(Item(aHGE, "img/Icon/SharpFlintstoneData.dds", "img/Icon/SharpFlintstoneData.dds", "SharpFlintstoneData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/WireData.dds", "img/Icon/WireData.dds", "WireData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/Flintstone1Data.dds", "img/Icon/Flintstone1Data.dds", "Flintstone1Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/Flintstone2Data.dds", "img/Icon/Flintstone2Data.dds", "Flintstone2Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/GuanoData.dds", "img/Icon/GuanoData.dds", "GuanoData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/SulphurData.dds", "img/Icon/SulphurData.dds", "SulphurData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/MagneticRockData.dds", "img/Icon/MagneticRockData.dds", "MagneticRockData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/CharcoalData.dds", "img/Icon/CharcoalData.dds", "CharcoalData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/GunpowderData.dds", "img/Icon/GunpowderData.dds", "GunpowderData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/LogData.dds", "img/Icon/LogData.dds", "LogData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/LogsData.dds", "img/Icon/LogsData.dds", "LogsData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/RopeData.dds", "img/Icon/RopeData.dds", "RopeData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/CoconutData.dds", "img/Icon/CoconutData.dds", "CoconutData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/DryLeavesData.dds", "img/Icon/DryLeavesData.dds", "DriedLeavesData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/CoconutHalf1Data.dds", "img/Icon/CoconutHalf1Data.dds", "CoconutHalf1Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/CoconutHalf2Data.dds", "img/Icon/CoconutHalf2Data.dds", "CoconutHalf2Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/FireData.dds", "img/Icon/FireData.dds", "FireData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/AxeData.dds", "img/Icon/AxeData.dds", "AxeData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/GoldNecklaceData.dds", "img/Icon/GoldNecklaceData.dds", "GoldNecklaceData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/RefinedLatexData.dds", "img/Icon/RefinedLatexData.dds", "RefinedLatexData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/BananaTreeLeaf1Data.dds", "img/Icon/BananaTreeLeaf1Data.dds", "BananaTreeLeaf1Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/BananaTreeLeaf2Data.dds", "img/Icon/BananaTreeLeaf2Data.dds", "BananaTreeLeaf2Data"));
		myForItemData.push_back(Item(aHGE, "img/Icon/BananaData.dds", "img/Icon/BananaData.dds", "BananaData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/DiamondData.dds", "img/Icon/DiamondData.dds", "DiamondData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/LatexStringedData.dds", "img/Icon/LatexStringedData.dds", "LatexStringedData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/FixedRubberBandData.dds", "img/Icon/FixedRubberBandData.dds", "FixedRubberBandData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/BrokenRubberBandData.dds", "img/Icon/BrokenRubberBandData.dds", "BrokenRubberBandData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/StickData.dds", "img/Icon/StickData.dds", "StickData"));
		//myForItemData.push_back(Item(aHGE, "img/Icon/RaftData.dds", "img/Icon/RaftData.dds", "RaftData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/GoldNecklaceData.dds", "img/Icon/GoldNecklaceData.dds", "GoldNecklaceData"));
		myForItemData.push_back(Item(aHGE, "img/Icon/LatexData.dds", "img/Icon/LatexData.dds", "LatexData"));
		//myForItemData.push_back(Item(aHGE, "img/Icon/BirdSuitData.dds", "img/Icon/BirdSuitData.dds", "BirdSuitData"));
		//myForItemData.push_back(Item(aHGE, "img/Icon/EstherData.dds", "img/Icon/EstherData.dds", "EstherData"));

		myIsBeingCalled = false;

		myCombinationAttempt = false;
		myCombinationResult = false;

		myItemPositionsX.push_back( myPosition.myX + 60.0f );
		myItemPositionsY.push_back( myPosition.myY + 70.0f );
		myItemPositionsX.push_back( myPosition.myX + 145.0f );
		myItemPositionsY.push_back( myPosition.myY + 70.0f );
		myItemPositionsX.push_back( myPosition.myX + 225.0f );
		myItemPositionsY.push_back( myPosition.myY + 70.0f );
		myItemPositionsX.push_back( myPosition.myX + 305.0f );
		myItemPositionsY.push_back( myPosition.myY + 70.0f );
		myItemPositionsX.push_back( myPosition.myX + 385.0f );
		myItemPositionsY.push_back( myPosition.myY + 70.0f );

		myItemPositionsX.push_back( myPosition.myX + 60.0f );
		myItemPositionsY.push_back( myPosition.myY + 150.0f );
		myItemPositionsX.push_back( myPosition.myX + 145.0f );
		myItemPositionsY.push_back( myPosition.myY + 150.0f );
		myItemPositionsX.push_back( myPosition.myX + 225.0f );
		myItemPositionsY.push_back( myPosition.myY + 150.0f );
		myItemPositionsX.push_back( myPosition.myX + 305.0f );
		myItemPositionsY.push_back( myPosition.myY + 150.0f );
		myItemPositionsX.push_back( myPosition.myX + 385.0f );
		myItemPositionsY.push_back( myPosition.myY + 150.0f );

		myItemPositionsX.push_back( myPosition.myX + 60.0f );
		myItemPositionsY.push_back( myPosition.myY + 230.0f );
		myItemPositionsX.push_back( myPosition.myX + 145.0f );
		myItemPositionsY.push_back( myPosition.myY + 230.0f );
		myItemPositionsX.push_back( myPosition.myX + 225.0f );
		myItemPositionsY.push_back( myPosition.myY + 230.0f );
		myItemPositionsX.push_back( myPosition.myX + 305.0f );
		myItemPositionsY.push_back( myPosition.myY + 230.0f );
		myItemPositionsX.push_back( myPosition.myX + 385.0f );
		myItemPositionsY.push_back( myPosition.myY + 230.0f );

		myCombiningItemPositionsX.push_back( myPosition.myX + 80.0f );
		myCombiningItemPositionsY.push_back( myPosition.myY + 355.0f );
		myCombiningItemPositionsX.push_back( myPosition.myX + 175.0f );
		myCombiningItemPositionsY.push_back( myPosition.myY + 355.0f );
		myCombiningItemPositionsX.push_back( myPosition.myX + 260.0f );
		myCombiningItemPositionsY.push_back( myPosition.myY + 355.0f );

		myButtonPosition.myX = myPosition.myX + 372;
		myButtonPosition.myY = myPosition.myY + 302;

	}

	~Inventory( )
	{
	}

	void HandleInput( InputWrapper &anInputHandler )
	{
		Vector2<float> tempMousePosition( static_cast<float>( anInputHandler.GetMousePosition( ).myX ), static_cast<float>( anInputHandler.GetMousePosition( ).myY ) );
		if( anInputHandler.KeyPressed( DIK_I ) )
		{
			SwitchState();
		}

		if( anInputHandler.ButtonClicked( 0 ) )
		{
			if( IsActive( ) == true )
			{
				if( IsItemMoving( ) == true )
				{
					if( IsItemInsideItemBoxes( ) == true )
					{
						if( IsInsideItemBox( tempMousePosition ) == true )
						{
							MakeItemNotMove( );
						}
						else
						{
							if( myCombiningItems.size( ) != 3 )
							{
								PutItemInCombinationBoxes( );
							}
						}
					}
					else if( IsItemInsideCombinationBoxes( ) == true )
					{
						if( IsInsideCombinationBox( tempMousePosition ) == true )
						{
							MakeItemNotMove( );
						}
						else
						{
							PutItemInItemBoxes( );
						}
					}
					else
					{
						MakeItemNotMove( );
					}
				}
				else
				{
					if( GetInsideItemBox( tempMousePosition ) == true )
					{
					}
					else if( GetInsideCombinationItemBox( tempMousePosition ) == true )
					{
					}
					else if( GetInsideButton( tempMousePosition ) == true )
					{			
						if(myCombiner.CombineThis( myItems, myCombiningItems ) == true)
						{							
							myCombinationAttempt = true;
							myCombinationResult = true;
						}
						else
						{
							myCombinationAttempt = true;
							myCombinationResult = false;
						}
					}
					else
					{
						if(myCombinationAttempt == true)
						{
							myCombinationAttempt = false;
							myCombinationResult = false;
						}
					}
				}
			}
		}
	}

	void SwitchState()
	{
		if( IsActive( ) == false )
		{
			MakeActive( );
		}
		else
		{
			MakeNotActive( );
		}
	}

	void MakeActive( )
	{
		myIsBeingCalled = true;
		EventSingelton::GetInstance()->myInventoryActive = true;
		EventSingelton::GetInstance()->myAvatarShouldAnimate = false;
	}

	void MakeNotActive( )
	{
		myIsBeingCalled = false;
		EventSingelton::GetInstance()->myInventoryActive = false;
		EventSingelton::GetInstance()->myAvatarShouldAnimate = true;
	}

	bool IsActive( )
	{
		if( myIsBeingCalled == true )
		{
			return true;
		}
		return false;
	}

	void Update( Vector2<float> someMousePosition, RenderData &someRenderData )
	{
		if(myIsBeingCalled==true)
		{
			for(unsigned int itemIndex = 0; itemIndex < myItems.size(); itemIndex++)
			{
				if(someMousePosition.myX > myItemPositionsX[itemIndex] && someMousePosition.myX < myItemPositionsX[itemIndex] + 85.0f )
				{
					if(someMousePosition.myY > myItemPositionsY[itemIndex] && someMousePosition.myY < myItemPositionsY[itemIndex] + 100.0f )
					{
						RenderMessage tempMessage;
						tempMessage.myPosition = Vector2<float>( someMousePosition.myX+20, someMousePosition.myY-20);
						tempMessage.myType = spriteRenderMessageType;
						someRenderData.myMessages.push_back(tempMessage);
						if(myItems[itemIndex].myID == "sharpFlintstone")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("SharpFlintstoneData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "wire")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("WireData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "flintstone1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("Flintstone1Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "flintstone2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("Flintstone2Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "stick")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("StickData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "axe")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("AxeData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "log")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LogData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "guano")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GuanoData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "charcoal")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CharcoalData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "gunpowder")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GunpowderData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "coconut half 1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutHalf1Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "coconut half 2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutHalf2Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "fire")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("FireData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "rubber string")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LatexStringedData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "combined rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("FixedRubberBandData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "Sulphur")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("SulphurData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "Guano")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GuanoData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "MagneticRock")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("MagneticRockData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "dried leaves")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("DriedLeavesData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LatexData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "coconut")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "engine belt")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BrokenRubberBandData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "Rope")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RopeData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "banana tree leaf 1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaTreeLeaf1Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "banana tree leaf 2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaTreeLeaf2Data")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "Diamond")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("DiamondData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "banana")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "logs")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LogsData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "refined rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RefinedLatexData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "raft")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RaftData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "gold necklace")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GoldNecklaceData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "bird suit")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BirdSuitData")].myInventorySprite);
						}
						else if(myItems[itemIndex].myID == "fainted ester")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("EstherData")].myInventorySprite);
						}
					}
				}
			}

			for(unsigned int itemIndex = 0; itemIndex < myCombiningItems.size(); itemIndex++)
			{
				if(someMousePosition.myX > myCombiningItemPositionsX[itemIndex] && someMousePosition.myX < myCombiningItemPositionsX[itemIndex] + 85.0f )
				{
					if(someMousePosition.myY > myCombiningItemPositionsY[itemIndex] && someMousePosition.myY < myCombiningItemPositionsY[itemIndex] + 100.0f )
					{
						RenderMessage tempMessage;
						tempMessage.myPosition = Vector2<float>( someMousePosition.myX+20, someMousePosition.myY-20);
						tempMessage.myType = spriteRenderMessageType;
						someRenderData.myMessages.push_back(tempMessage);
						if(myCombiningItems[itemIndex].myID == "sharpFlintstone")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("SharpFlintstoneData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "wire")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("WireData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "flintstone1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("Flintstone1Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "flintstone2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("Flintstone2Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "stick")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("StickData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "axe")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("AxeData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "log")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LogData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "guano")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GuanoData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "charcoal")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CharcoalData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "gunpowder")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GunpowderData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "coconut half 1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutHalf1Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "coconut half 2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutHalf2Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "fire")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("FireData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "rubber string")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LatexStringedData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "combined rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("FixedRubberBandData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "Sulphur")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("SulphurData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "Guano")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GuanoData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "MagneticRock")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("MagneticRockData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "dried leaves")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("DriedLeavesData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LatexData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "coconut")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("CoconutData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "engine belt")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BrokenRubberBandData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "Rope")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RopeData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "banana tree leaf 1")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaTreeLeaf1Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "banana tree leaf 2")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaTreeLeaf2Data")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "Diamond")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("DiamondData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "banana")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BananaData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "logs")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("LogsData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "refined rubber")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RefinedLatexData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "raft")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("RaftData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "gold necklace")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("GoldNecklaceData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "bird suit")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("BirdSuitData")].myInventorySprite);
						}
						else if(myCombiningItems[itemIndex].myID == "fainted ester")
						{
							someRenderData.mySprites.push_back(&myForItemData[GetDataIndex("EstherData")].myInventorySprite);
						}
					}
				}
			}
		}
	}

	int GetDataIndex(std::string anID)
	{
		for(unsigned int dataIndex = 0; dataIndex < myForItemData.size(); dataIndex++)
		{
			if(myForItemData[dataIndex].myID == anID)
			{
				return dataIndex;
			}
		}
		return 0;
	}

	void Render( RenderData &someRenderData, float aMouseX, float aMouseY )
	{
		if( IsActive( ) == true )
		{
			RenderMessage tempMessage;

			tempMessage.myPosition = myPosition;
			tempMessage.myType = spriteRenderMessageType;
			someRenderData.myMessages.push_back(tempMessage);
			someRenderData.mySprites.push_back(&mySprite);

			for( unsigned i = 0; i < myItems.size( ); i++ )
			{
				if( myItems[i].IsFollowingMouse( ) == false )
				{
					myItems[i].Render( someRenderData, myItemPositionsX[i], myItemPositionsY[i] );
				}
				else
				{
					myItems[i].Render( someRenderData, aMouseX, aMouseY );
				}
			}
			for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
			{
				if( myCombiningItems[i].IsFollowingMouse( ) == false )
				{
					myCombiningItems[i].Render( someRenderData, myCombiningItemPositionsX[i], myCombiningItemPositionsY[i] );
				}
				else
				{
					myCombiningItems[i].Render( someRenderData, aMouseX, aMouseY );
				}
			}
			if( aMouseX < myButtonPosition.myX + 68 && aMouseX > myButtonPosition.myX )
			{
				if( aMouseY < myButtonPosition.myY + 48 && aMouseY > myButtonPosition.myY )
				{
					Vector2<float> tempVector(myButtonPosition.myX, myButtonPosition.myY - 10);					

					RenderMessage tempMessage;

					tempMessage.myPosition = tempVector;
					tempMessage.myType = spriteRenderMessageType;
					someRenderData.myMessages.push_back(tempMessage);
					someRenderData.mySprites.push_back(&myGlow);
				}
			}
			if(myCombinationAttempt == true)
			{
				RenderMessage tempMessage;
				Vector2<float> tempPosition(280.0f, 200.0f);

				if(myCombinationResult == true)
				{
					tempMessage.myPosition = tempPosition;
					tempMessage.myType = spriteRenderMessageType;
					someRenderData.myMessages.push_back(tempMessage);
					someRenderData.mySprites.push_back(&myCombineSuccess);
				}
				else
				{
					tempMessage.myPosition = tempPosition;
					tempMessage.myType = spriteRenderMessageType;
					someRenderData.myMessages.push_back(tempMessage);
					someRenderData.mySprites.push_back(&myCombineFailure);
				}
			}
		}
	}

	void AddItem( Item &anItem )
	{
		myItems.push_back( anItem );
	}

	void SetTexture( HTEXTURE &aTextureName )
	{
		mySprite.SetTexture( aTextureName );
	}

	bool CheckForItem(std::string aItemID)
	{
		int nbrOfItems = myItems.size();
		for (int itemChecked = 0; itemChecked < nbrOfItems; itemChecked++)
		{
			if ( myItems[itemChecked].myID.compare(aItemID) == 0 )
			{
				return true;
			}
		}
		return false;
	}

	bool DeleteItem(std::string aItemID)
	{
		int nbrOfItems = myItems.size();
		for (int itemChecked = 0; itemChecked < nbrOfItems; itemChecked++)
		{
			if ( myItems[itemChecked].myID.compare(aItemID) == 0 )
			{
				myItems.erase(myItems.begin() + itemChecked);
				return true;
			}
		}
		return false;
	}

	bool TakeOutItem(std::string aItemID, Item &aReturnItem)
	{
		int nbrOfItems = myItems.size();
		for (int itemChecked = 0; itemChecked < nbrOfItems; itemChecked++)
		{
			if ( myItems[itemChecked].myID.compare(aItemID) == 0 )
			{
				aReturnItem = myItems[itemChecked];
				myItems.erase(myItems.begin() + itemChecked);
				return true;
			}
		}
		return false;
	}

	Combine myCombiner;
	std::vector<Item> myItems;
	std::vector<Item> myCombiningItems;

	std::vector<Item> myForItemData;

private:

	Vector2<float> myPosition;

	std::vector<float> myItemPositionsX;
	std::vector<float> myItemPositionsY;

	std::vector<Vector2<float> > myItemPositions;
	
	std::vector<Item> myFollowingMouseItems;
	Vector2<float> myFollowingMousePositions;

	std::vector<float> myCombiningItemPositionsX;
	std::vector<float> myCombiningItemPositionsY;

	StaticSprite mySprite;
	StaticSprite myGlow;

	StaticSprite myCombineSuccess;
	StaticSprite myCombineFailure;

	Vector2<float> myButtonPosition;

	bool myIsBeingCalled;

	bool myCombinationAttempt;
	bool myCombinationResult;

	bool GetInsideItemBox( Vector2<float> &aMousePosition )
	{
		for( unsigned i = 0; i < myItems.size( ); i++ )
		{
			if( aMousePosition.myX > myItemPositionsX[i] && aMousePosition.myX < myItemPositionsX[i] + 85.0f )
			{
				if( aMousePosition.myY < myItemPositionsY[i] + 85.0f && aMousePosition.myY > myItemPositionsY[i] )
				{
					myItems[i].FollowMouse( );
					return true;
				}
			}
		}

		return false;
	}

	bool GetInsideCombinationItemBox( Vector2<float> &aMousePosition )
	{
		for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
		{
			if( aMousePosition.myX > myCombiningItemPositionsX[i] && aMousePosition.myX < myCombiningItemPositionsX[i] + 85.0f )
			{
				if( aMousePosition.myY < myCombiningItemPositionsY[i] + 85.0f && aMousePosition.myY > myCombiningItemPositionsY[i] )
				{
					myCombiningItems[i].FollowMouse( );
					return true;
				}
			}
		}

		return false;
	}

	bool IsItemMoving( )
	{
		for( unsigned i = 0; i < myItems.size( ); i++ )
		{
			if( myItems[i].IsFollowingMouse( ) == true )
			{
				return true;
			}
		}
		for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
		{
			if( myCombiningItems[i].IsFollowingMouse( ) == true )
			{
				return true;
			}
		}
		return false;
	}

	bool MakeItemNotMove( )
	{
		for( unsigned i = 0; i < myItems.size( ); i++ )
		{
			if( myItems[i].IsFollowingMouse( ) == true )
			{
				myItems[i].StopFollowMouse( );
			}
		}
		for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
		{
			if( myCombiningItems[i].IsFollowingMouse( ) == true )
			{
				myCombiningItems[i].StopFollowMouse( );
			}
		}
		return true;
	}

	bool IsInsideItemBox( Vector2<float> &aMousePosition )
	{
		for( unsigned i = 0; i < myItemPositionsX.size( ); i++ )
		{
			if( aMousePosition.myX < myItemPositionsX[i]+85.0f && aMousePosition.myX > myItemPositionsX[i] )
			{
				if( aMousePosition.myY < myItemPositionsY[i]+80.0f && aMousePosition.myY > myItemPositionsY[i] )
				{
					return true;
				}
			}
		}

		return false;
	}

	bool IsInsideCombinationBox( Vector2<float> &aMousePosition )
	{
		for( unsigned i = 0; i < myCombiningItemPositionsX.size( ); i++ )
		{
			if( aMousePosition.myX < myCombiningItemPositionsX[i]+95.0f && aMousePosition.myX > myCombiningItemPositionsX[i] )
			{
				if( aMousePosition.myY < myCombiningItemPositionsY[i]+80.0f && aMousePosition.myY > myCombiningItemPositionsY[i] )
				{
					return true;
				}
			}
		}

		return false;
	}

	bool IsItemInsideItemBoxes( )
	{
		for( unsigned i = 0; i < myItems.size( ); i++ )
		{
			if( myItems[i].IsFollowingMouse( ) == true )
			{
				return true;
			}
		}
		return false;
	}
	bool IsItemInsideCombinationBoxes( )
	{
		for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
		{
			if( myCombiningItems[i].IsFollowingMouse( ) == true )
			{
				return true;
			}
		}
		return false;
	}

	void PutItemInItemBoxes( )
	{
		for( unsigned i = 0; i < myCombiningItems.size( ); i++ )
		{
			if( myCombiningItems[i].IsFollowingMouse( ) == true )
			{
				if( myCombiningItems[i].myID == "wire" )
				{
					MakeItemNotMove( );
					myCombiningItems.erase( myCombiningItems.begin( ) + i );
					return;
				}
				MakeItemNotMove( );
				myItems.push_back( myCombiningItems[i] );
				myCombiningItems.erase( myCombiningItems.begin( ) + i );
			}
		}
	}
	void PutItemInCombinationBoxes( )
	{
		for( unsigned i = 0; i < myItems.size( ); i++ )
		{
			if( myItems[i].IsFollowingMouse( ) == true )
			{
				if( myItems[i].myID == "wire" )
				{
					MakeItemNotMove( );
					myCombiningItems.push_back( myItems[i] );
					return;
				}
				MakeItemNotMove( );
				myCombiningItems.push_back( myItems[i] );
				myItems.erase( myItems.begin( ) + i );
			}
		}
	}

	bool GetInsideButton( Vector2<float> &aMousePosition )
	{
		if( aMousePosition.myX < myButtonPosition.myX + 68 && aMousePosition.myX > myButtonPosition.myX )
		{
			if( aMousePosition.myY < myButtonPosition.myY + 48 && aMousePosition.myY > myButtonPosition.myY )
			{
				return true;
			}
		}
		return false;
	}
};

#endif