#ifndef ___JUNGLE_CRASH_SITE_H___
#define ___JUNGLE_CRASH_SITE_H___


#include "LevelBaseData.h"
#include "Curtain.h"
#include "LogTree.h"


class JungleCrashSite : public LevelBaseData
{

public:

	JungleCrashSite( );
	JungleCrashSite( const LevelBaseData &aLevelBaseData );
	~JungleCrashSite( );

	void LevelSpecificUpdate(Avatar &aAvatar, Camera &aCamera, float aDelta);
	void LevelSpecificRender(RenderData &aRenderData, Camera &aCamera);
	void LevelSpecificHandleInput(InputWrapper &aInputWrapper, float aDelta, Inventory &aInventory);
	virtual void ConversationEvent(float elapsTime, Avatar &aAvatar, Inventory &aInventory);

	void InitializeConversations();

	void Initialize( HGE *aHGE );

	bool GetActivatedRaft( );
	void MakeRaftActive( );
	void MakeRaftNotActive( );

	Curtain myCurtain;
	Raft myRaft;
	LogTree myLogTree;

	bool myChangingConversation;
	bool myHaveCompletedRaftConversation;

private:

};


#endif