#include "LevelConversation.h"

LevelConversation::LevelConversation()
{}
LevelConversation::LevelConversation(HGE *aHGE, std::string aConversationID, bool aHaveMenu):
myHGE(aHGE)
{
	myConversationID = aConversationID;
	myDialoge = Dialogue(aHGE);
	myHaveMenu = aHaveMenu;
	if(aHaveMenu == true)
	{
		myMenus = Menu(aHGE);
	}
	myActiveConversation = false;
}
LevelConversation::LevelConversation(const LevelConversation &aLevelConversation):
myHGE(aLevelConversation.myHGE)
{
	myConversationID = aLevelConversation.myConversationID;
	myDialoge = aLevelConversation.myDialoge;
	myMenus = aLevelConversation.myMenus;

	myHaveMenu = aLevelConversation.myHaveMenu;
	myActiveMenu = aLevelConversation.myActiveMenu;
	myActiveConversation = aLevelConversation.myActiveConversation;
}
LevelConversation::~LevelConversation()
{}

void LevelConversation::Initialize()
{
	myDialoge.Initialize();
	if(myHaveMenu == true)
	{
		myMenus.Initialize();
	}
}
void LevelConversation::Update(float aElapseTime)
{
	myDialoge.Update();
	if(myHaveMenu == true)
	{
 		myMenus.Update(aElapseTime);
	}
}
void LevelConversation::Input(InputWrapper &aInput)
{
	myDialoge.Input(aInput);
}
void LevelConversation::Render(RenderData &someRenderData)
{
	myDialoge.Render(someRenderData);
}

// dialoge
void LevelConversation::AddDialogeText(std::string aDialoge)
{
	myDialoge.AddConversationText(aDialoge);
}

// menu
void LevelConversation::AddMenuItem(std::string aItemName)
{
	myMenus.AddMenuItem(aItemName);
}

