#ifndef _LEVEL_CONVERSATION_H_
#define _LEVEL_CONVERSATION_H_
#include "Dialogue.h"
#include "Menu.h"
#include <string>
#include <vector>
#include "RenderInformation.h"

class LevelConversation
{
public:
	LevelConversation();
	LevelConversation(HGE* aHGE, std::string aConversationID, bool aHaveMenu);
	LevelConversation(const LevelConversation& aLevelConversation);
	~LevelConversation();

	void Initialize();
	void Update(float aElapseTime);
	void Input(InputWrapper& aInput);
	void Render(RenderData &someRenderData);
	
	// dialoge
	void AddDialogeText(std::string aDialoge);

	// menu
	void AddMenu(std::string aMenuID);
	void AddMenuItem(std::string aMenuID);
	void ActiveMenu(std::string aID);
	Menu GetActiveMenu();

	// component
	std::string myConversationID;
	Dialogue myDialoge;
	Menu myMenus;
	
	bool myActiveConversation;
private:
	HGE* myHGE;
	
	bool myHaveMenu;
	
	// menu
	int myActiveMenu;
};
#endif