#ifndef ___LOG_TREE_H___
#define ___LOG_TREE_H___

#include "RenderInformation.h"
#include "Vector.h"
#include "InputWrapper/InputWrapper.h"


class LogTree
{
public:
	LogTree();
	LogTree(HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition);
	LogTree(HGE* aHGE);
	~LogTree();

	bool IsAvatarInProximity(Vector2<float>& anAvatarPosition);
	
	void InputHandling(InputWrapper& aInput);
	void Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition);
	void Render(RenderData &someRenderData);

	
	bool IsInterractable();
	void MakeInterractable();
	void MakeNotInterractable();

	void SwitchState();
	void MakeActive();
	void MakeNotActive();
	bool IsActive();


private:

	HGE* myHGE;

	StaticSprite mySprite;
	StaticSprite myInterractionButton;

	Vector2<float> myWorldSpacePosition;
	Vector2<float> myCameraSpacePosition;
	
	bool myAvatarNear;
	bool myIsBeingCalled;
};

#endif