#include "MagneticStonePH.h"


MagneticStonePH::MagneticStonePH()
{
}

MagneticStonePH::MagneticStonePH( HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition )
{
	mySprite = StaticSprite(aHGE, aFileName);
	myWorldSpacePosition = aWorldSpacePosition;

	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

MagneticStonePH::~MagneticStonePH()
{
}

void MagneticStonePH::InputHandling(InputWrapper& aInput)
{
	aInput;
	MakeActive( );
}

void MagneticStonePH::Render(RenderData &someRenderData)
{
	RenderMessage tempMessage;

	tempMessage.myPosition = myCameraSpacePosition;
	tempMessage.myType = spriteRenderMessageType;

	someRenderData.myMessages.push_back(tempMessage);
	someRenderData.mySprites.push_back(&mySprite);

	if(IsInterractable() == true)
	{
		tempMessage.myPosition = Vector2<float>( myCameraSpacePosition.myX + 30, myCameraSpacePosition.myY - 60);
		tempMessage.myType = spriteRenderMessageType;

		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myInterractionButton );
	}
}

void MagneticStonePH::Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition)
{
	myCameraSpacePosition = myWorldSpacePosition - aCameraPosition;
	IsAvatarInProximity(anAvatarPosition);
}

bool MagneticStonePH::IsAvatarInProximity(Vector2<float>& anAvatarPosition)
{
	if( (anAvatarPosition.myX < myWorldSpacePosition.myX + 50) && (anAvatarPosition.myX > myWorldSpacePosition.myX - 50) )
	{
		if( (anAvatarPosition.myY < myWorldSpacePosition.myY + 50) && (anAvatarPosition.myY > myWorldSpacePosition.myY - 50) )
		{
			MakeInterractable();
			return true;
		}
	}

	MakeNotInterractable();
	return false;
}

bool MagneticStonePH::IsInterractable()
{
	return (myAvatarNear);
}

void MagneticStonePH::MakeInterractable()
{
	myAvatarNear = true;
}

void MagneticStonePH::MakeNotInterractable()
{
	myAvatarNear = false;
}

void MagneticStonePH::SwitchState()
{
	if( IsActive() == false )
	{
		MakeActive();
	}
	else
	{
		MakeNotActive();
	}
}

void MagneticStonePH::MakeActive()
{
	myIsBeingCalled = true;
}

void MagneticStonePH::MakeNotActive()
{
	myIsBeingCalled = false;
}

bool MagneticStonePH::IsActive()
{
	if(myIsBeingCalled == true)
	{
		return true;
	}
	return false;
}

