#include "Map.h"
#include <vector>
#include "Vector.h"
#include <assert.h>


Map::Map(void)
{
}

Map::~Map(void)
{
}

int Map::GetMapHeight()
{
	assert( (myFloor.size() > 0) && "GetMapHeight() used on map without tiles (uninitialized)." );
	return static_cast<int>(myFloor[0].GetSpriteHeight());
}

int Map::GetMapWidth()
{
	assert( (myFloor.size() > 0) && "GetMapWidth() used on map without tiles (uninitialized)." );
	return static_cast<int>(myFloor[0].GetSpriteWidth());
}

void Map::AddFloorSprite(StaticSprite aSprite, Vector2<float> aPosition)
{
	myFloor.push_back(aSprite);
	myFloorPosition.push_back(aPosition);
}

void Map::AddOverlaySprite(StaticSprite aSprite, Vector2<float> aPosition)
{
	myOverlay.push_back(aSprite);
	myOverlayPosition.push_back(aPosition);
}

void Map::RenderFloor(RenderData &someRenderData, Vector2<float> aCameraPosition)
{
	int floorsToRender = myFloor.size();
	for ( int floorRendered = 0; floorRendered < floorsToRender; floorRendered++)
	{
		RenderMessage tempMessage;
		tempMessage.myPosition = myFloorPosition[floorRendered] - aCameraPosition;
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myFloor[floorRendered] );
	}
}

void Map::RenderOverlay(RenderData &someRenderData, Vector2<float> aCameraPosition)
{
	int overlayToRender = myOverlay.size();
	for ( int overlayRendered = 0; overlayRendered < overlayToRender; overlayRendered++)
	{
		RenderMessage tempMessage;
		tempMessage.myPosition = myOverlayPosition[overlayRendered] - aCameraPosition;
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myOverlay[overlayRendered] );
	}
}