#ifndef _MENU_COMPONENT_H_
#define _MENU_COMPONENT_H_

#include "Arrays\GrowingArray.h"
#include "inputwrapper/inputwrapper.h"
#include "Font.h"
#include "Vector.h"

#include <string>


class MenuComponent
{
public:
	MenuComponent();
	MenuComponent(HGE* aHge);
	MenuComponent(const MenuComponent& aMenuComponent);
	~MenuComponent();

	void Initialize();
	void Input(InputWrapper& aInput, float aInputElapsTime);
	void Update(float aElapseTime);
	void Render();

	void AddMenuItem(std::string aItemText);
	int GetHighlightedItem();

	void SetPosition(const float aPositionX, const float aPositionY);
	void SetPosition(const Vector2<float> aPosition);
	Vector2<float> GetPosition();

	void SetHighlightedColour(const int aAlpha, const int aRed, const int aGreen, const int aBlue);
	void SetHighlightedColour(const Vector4<int> aHighlightedColour);
	
	void SetNormalColour(const int aAlpha, const int aRed, const int aGreen, const int aBlue);
	void SetNormalColour(const Vector4<int> aNormalColour);

	void SetMenuFont(std::string aFontName);
	void SetMenuTextAlign(int aAlign);

	void MenuMarkingDown();
	void MenuMarkingUp();

	Font* GetFontRef(int index);
	Tools::GrowingArray<Font, int> GetItemList();
private:
	HGE* myHge;
	Tools::GrowingArray<Font, int> myItemList;	
	int myHighlightedItem;

	std::string myMenuFont;
	int myMenuTextAlign;
	Vector2<float> myPosition;
	Vector4<int> myHighlightedColour;
	Vector4<int> myNormalColour;

	float theInputElapseTime;

	float myFirstInputElapsedTime;
	float mySecondInputElapsedTime;
};
#endif