#include "NativeBoy.h"


NativeBoy::NativeBoy()
{
}

NativeBoy::NativeBoy( HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition )
{
	mySprite = StaticSprite(aHGE, aFileName);
	myWorldSpacePosition = aWorldSpacePosition;

	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

NativeBoy::NativeBoy(HGE* aHGE)
:myHGE(aHGE)
{	
	mySprite = StaticSprite(myHGE, "img/NPCs/sprite_boy.dds");
	myWorldSpacePosition = Vector2<float>(142, 791);
	
	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

NativeBoy::~NativeBoy()
{
}

void NativeBoy::InputHandling(InputWrapper& aInput)
{
	aInput;
	SwitchState( );
}

void NativeBoy::Render(RenderData &someRenderData)
{
	RenderMessage tempMessage;

	tempMessage.myPosition = myCameraSpacePosition;
	tempMessage.myType = spriteRenderMessageType;

	someRenderData.myMessages.push_back(tempMessage);
	someRenderData.mySprites.push_back(&mySprite);

	if(IsInterractable() == true)
	{
		tempMessage.myPosition = Vector2<float>( myCameraSpacePosition.myX + 30, myCameraSpacePosition.myY - 60);
		tempMessage.myType = spriteRenderMessageType;

		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myInterractionButton );
	}
}

void NativeBoy::Update(Vector2<float> aCameraPosition)
{
	myCameraSpacePosition = myWorldSpacePosition - aCameraPosition;
}

bool NativeBoy::IsAvatarInProximity(Vector2<float>& anAvatarPosition)
{
	if( (anAvatarPosition.myX < myWorldSpacePosition.myX + 130) && (anAvatarPosition.myX > myWorldSpacePosition.myX - 130) )
	{
		if( (anAvatarPosition.myY < myWorldSpacePosition.myY + 130) && (anAvatarPosition.myY > myWorldSpacePosition.myY - 130) )
		{
			MakeInterractable();
			return true;
		}
	}

	MakeNotInterractable();
	return false;
}

bool NativeBoy::IsInterractable()
{
	return (myAvatarNear);
}

void NativeBoy::MakeInterractable()
{
	myAvatarNear = true;
}

void NativeBoy::MakeNotInterractable()
{
	myAvatarNear = false;
}

void NativeBoy::SwitchState()
{
	if( IsActive() == false )
	{
		MakeActive();
	}
	else
	{
		MakeNotActive();
	}
}

void NativeBoy::MakeActive()
{
	myIsBeingCalled = true;
}

void NativeBoy::MakeNotActive()
{
	myIsBeingCalled = false;
}

bool NativeBoy::IsActive()
{
	if(myIsBeingCalled == true)
	{
		return true;
	}
	return false;
}

