#include "NativeVillager.h"

NativeVillager::NativeVillager()
{
}

NativeVillager::NativeVillager( HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition )
{
	mySprite = StaticSprite(aHGE, aFileName);
	myWorldSpacePosition = aWorldSpacePosition;

	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

NativeVillager::NativeVillager(HGE* aHGE)
:myHGE(aHGE)
{	
	mySprite = StaticSprite(myHGE, "img/NPCs/sprite_native_npc_standing.dds");
	myWorldSpacePosition = Vector2<float>(1829, 962);
	
	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

NativeVillager::~NativeVillager()
{
}

void NativeVillager::InputHandling(InputWrapper& aInput)
{
	aInput;
	SwitchState( );
}

void NativeVillager::Render(RenderData &someRenderData)
{
	RenderMessage tempMessage;

	tempMessage.myPosition = myCameraSpacePosition;
	tempMessage.myType = spriteRenderMessageType;

	someRenderData.myMessages.push_back(tempMessage);
	someRenderData.mySprites.push_back(&mySprite);

	if(IsInterractable() == true)
	{
		tempMessage.myPosition = Vector2<float>( myCameraSpacePosition.myX + 30, myCameraSpacePosition.myY - 60);
		tempMessage.myType = spriteRenderMessageType;

		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myInterractionButton );
	}
}

void NativeVillager::Update(Vector2<float> aCameraPosition)
{
	myCameraSpacePosition = myWorldSpacePosition - aCameraPosition;
}

bool NativeVillager::IsAvatarInProximity(Vector2<float>& anAvatarPosition)
{
	if( (anAvatarPosition.myX < myWorldSpacePosition.myX + 130) && (anAvatarPosition.myX > myWorldSpacePosition.myX - 130) )
	{
		if( (anAvatarPosition.myY < myWorldSpacePosition.myY + 130) && (anAvatarPosition.myY > myWorldSpacePosition.myY - 130) )
		{
			MakeInterractable();
			return true;
		}
	}

	MakeNotInterractable();
	return false;
}

bool NativeVillager::IsInterractable()
{
	return (myAvatarNear);
}

void NativeVillager::MakeInterractable()
{
	myAvatarNear = true;
}

void NativeVillager::MakeNotInterractable()
{
	myAvatarNear = false;
}

void NativeVillager::SwitchState()
{
	if( IsActive() == false )
	{
		MakeActive();
	}
	else
	{
		MakeNotActive();
	}
}

void NativeVillager::MakeActive()
{
	myIsBeingCalled = true;
}

void NativeVillager::MakeNotActive()
{
	myIsBeingCalled = false;
}

bool NativeVillager::IsActive()
{
	if(myIsBeingCalled == true)
	{
		return true;
	}
	return false;
}

