#ifndef ___NATIVE_VILLAGER_H___
#define ___NATIVE_VILLAGER_H___

#include "RenderInformation.h"
#include "Vector.h"
#include "InputWrapper/InputWrapper.h"


class NativeVillager
{
public:
	NativeVillager();
	NativeVillager(HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition);
	NativeVillager(HGE* aHGE);
	~NativeVillager();

	bool IsAvatarInProximity(Vector2<float>& anAvatarPosition);
	
	void InputHandling(InputWrapper& aInput);
	void Update(Vector2<float> aCameraPosition);
	void Render(RenderData &someRenderData);

	
	bool IsInterractable();
	void MakeInterractable();
	void MakeNotInterractable();

	void SwitchState();
	void MakeActive();
	void MakeNotActive();
	bool IsActive();


private:

	HGE* myHGE;

	StaticSprite mySprite;
	StaticSprite myInterractionButton;

	Vector2<float> myWorldSpacePosition;
	Vector2<float> myCameraSpacePosition;
	
	bool myAvatarNear;
	bool myIsBeingCalled;
};

#endif