#ifndef NOTEBOOK_H_
#define NOTEBOOK_H_

#include "Vector2.h"
#include "RenderInformation.h"
#include "InputWrapper/InputWrapper.h"

class Inventory;

class Notebook
{
public:
	enum MachineAvailable
	{
		ITEM_BELT,
		ITEM_CRYSTAL,
		ITEM_MAGNET,
		ITEM_WIRE
	};	
	
	Notebook();
	Notebook(HGE* aHGE);
	~Notebook();

	void InputHandling(InputWrapper& aInput);
	void Render(RenderData &someRenderData);

	void ObtainItemUpdate(Inventory &aInventory);
	void SwitchState();
	void MakeActive();
	void MakeNotActive();
	bool IsActive();

private:

	Vector2<float> myPosition;

	bool myIsBeingCalled;

	StaticSprite mySprite;
	std::vector<StaticSprite> myMachineAvailableSprite;
	std::bitset<4> myMachineAvailable;
};

#endif
