#pragma once
#include "Vector.h"
#include "AnimationBase.h"
#include "RenderInformation.h"
#include "InputWrapper/InputWrapper.h"

class QuitMenu
{
public:
	QuitMenu();
	QuitMenu(HGE* aHge);
	~QuitMenu(void);

	void Initialize();
	void Render(RenderData &someRenderData);
	void HandleInput(InputWrapper &aInput);

private:
	AnimationBase myBackground;
	AnimationBase myExitButton;
	AnimationBase myContinueButton;

	Vector2<float> myPosition;
	Vector2<float> myContinueButtonOffset;
	Vector2<float> myExitButtonOffset;

	Vector2<float> exitButtonMin;
	Vector2<float> exitButtonMax;
	Vector2<float> continueButtonMin;
	Vector2<float> continueButtonMax;
};
