#include "Raft.h"


Raft::Raft()
{
}

Raft::Raft( HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition )
{
	mySprite = StaticSprite(aHGE, aFileName);
	myWorldSpacePosition = aWorldSpacePosition;

	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );

	mySendToRight = false;
	mySendToLeft = false;
	myAppear = false;
}

Raft::~Raft()
{
}

void Raft::InputHandling(InputWrapper& aInput)
{
	aInput;
	if( IsInterractable( ) == true )
	{
		myIsBeingCalled = true;
	}
	else
	{
		SwitchState( );
	}
}

void Raft::Render(RenderData &someRenderData)
{
	if( myAppear == true )
	{
		RenderMessage tempMessage;

		tempMessage.myPosition = myCameraSpacePosition;
		tempMessage.myType = spriteRenderMessageType;

		someRenderData.myMessages.push_back(tempMessage);
		someRenderData.mySprites.push_back(&mySprite);

		if(IsInterractable() == true)
		{
			tempMessage.myPosition = Vector2<float>( myCameraSpacePosition.myX + 30, myCameraSpacePosition.myY - 60);
			tempMessage.myType = spriteRenderMessageType;

			someRenderData.myMessages.push_back( tempMessage );
			someRenderData.mySprites.push_back( &myInterractionButton );
		}
	}
}

Vector2<float> Raft::Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition, Vector2<float> &aRobotPosition)
{
	myCameraSpacePosition = myWorldSpacePosition - aCameraPosition;
	IsAvatarInProximity(anAvatarPosition);

	if( myIsBeingCalled == true )
	{
		if( anAvatarPosition.myX < 1097.0f)
		{
			mySendToRight = true;
		}
		else
		{
			mySendToLeft = true;
		}

		if(mySendToRight == true )
		{
			anAvatarPosition = Vector2<float>( 1468, 488 );
			mySendToRight = false;
			myIsBeingCalled = false;
			myWorldSpacePosition = Vector2<float>( 1331, 543 );
			aRobotPosition = Vector2<float>(anAvatarPosition.myX + 50, anAvatarPosition.myY );
			return anAvatarPosition;
		}
		else if( mySendToLeft == true )
		{
			anAvatarPosition = Vector2<float>( 681, 379 );
			mySendToLeft = false;
			myIsBeingCalled = false;
			myWorldSpacePosition = Vector2<float>( 831, 468 );
			aRobotPosition = Vector2<float>(anAvatarPosition.myX - 50, anAvatarPosition.myY );
			return anAvatarPosition;
		}
	}
	return Vector2<float>( 0, 0 );
}

bool Raft::IsAvatarInProximity(Vector2<float>& anAvatarPosition)
{
	if( (anAvatarPosition.myX < myWorldSpacePosition.myX + 130) && (anAvatarPosition.myX > myWorldSpacePosition.myX - 130) )
	{
		if( (anAvatarPosition.myY < myWorldSpacePosition.myY + 130) && (anAvatarPosition.myY > myWorldSpacePosition.myY - 130) )
		{
			MakeInterractable();
			return true;
		}
	}

	MakeNotInterractable();
	return false;
}

bool Raft::IsInterractable()
{
	return (myAvatarNear);
}

void Raft::MakeInterractable()
{
	myAvatarNear = true;
}

void Raft::MakeNotInterractable()
{
	myAvatarNear = false;
	myIsBeingCalled = false;
}

void Raft::SwitchState()
{
	if( IsActive() == false )
	{
		MakeActive();
	}
	else
	{
		MakeNotActive();
	}
}

void Raft::MakeActive()
{
	myIsBeingCalled = true;
}

void Raft::MakeNotActive()
{
	myIsBeingCalled = false;
}

bool Raft::IsActive()
{
	if(myIsBeingCalled == true)
	{
		return true;
	}
	return false;
}

bool Raft::GetAppear( )
{
	return myAppear;
}

void Raft::MakeAppear( )
{
	myAppear = true;
}

void Raft::MakeNotAppear( )
{
	myAppear = false;
}