#ifndef ___RAFT_H___
#define ___RAFT_H___

#include "RenderInformation.h"
#include "Vector.h"
#include "InputWrapper/InputWrapper.h"


class Raft
{
public:
	Raft();
	Raft(HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition);
	~Raft();

	bool IsAvatarInProximity(Vector2<float>& anAvatarPosition);
	
	void InputHandling(InputWrapper& aInput);
	Vector2<float> Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition, Vector2<float> &aRobot);
	void Render(RenderData &someRenderData);

	bool GetAppear( );
	void MakeAppear( );
	void MakeNotAppear( );

	bool IsInterractable();
	void MakeInterractable();
	void MakeNotInterractable();

	void SwitchState();
	void MakeActive();
	void MakeNotActive();
	bool IsActive();


private:

	HGE* myHGE;

	bool mySendToRight;
	bool mySendToLeft;

	bool myAppear;

	StaticSprite mySprite;
	StaticSprite myInterractionButton;

	Vector2<float> myWorldSpacePosition;
	Vector2<float> myCameraSpacePosition;
	
	bool myAvatarNear;
	bool myIsBeingCalled;
};

#endif