#ifndef ___RANDOM_SPOT_H___
#define ___RANDOM_SPOT_H___


#include "Vector.h"


class RandomHotSpot
{

public:

	RandomHotSpot( const RandomHotSpot &aRandomHotSpot )
	{

		myBoxSpot = aRandomHotSpot.myBoxSpot;
		myRandomHotSpotConnex = aRandomHotSpot.myRandomHotSpotConnex;
		myHeight = aRandomHotSpot.myHeight;
		myWidth = aRandomHotSpot.myWidth;
		myID = aRandomHotSpot.myID;

	}

	/*By sending in position the height and width starting point
	is already defined so therefor you only need to send in a
	height and a width.
	
	
	 ______________________________________________________
	|<-aPosition.myX && aPosition.myY              aWidth->|
	|                                                      |
	|                                                      |
	|                                                      |
	|                                                      |
	|                                                      |
	|                                                      |
	|                                                      |
	|                       aHeight                        |
	|                          |                           |
	|                          v                           |
	 */
	RandomHotSpot( Vector2<float> aPosition, float aWidth, float aHeight, std::string anID )
	{

		myBoxSpot.myX = aPosition.myX;
		myBoxSpot.myY = aPosition.myY;
		myBoxSpot.myZ = aPosition.myX + aWidth;
		myBoxSpot.myW = aPosition.myY + aHeight;

		myHeight = aHeight;
		myWidth = aWidth;

		myID = anID;

	}

	~RandomHotSpot( )
	{
	}

	bool IsAvatarInsideMe( Vector2<float> &aPosition )
	{
		if( aPosition.myX < myBoxSpot.myX )
		{
			return false;
		}
		if( aPosition.myY < myBoxSpot.myY )
		{
			return false;
		}
		if( aPosition.myX > myBoxSpot.myZ )
		{
			return false;
		}
		if( aPosition.myY > myBoxSpot.myW )
		{
			return false;
		}

		return true;

	}

	Vector4<float> GetBoxSpot( )
	{
		return myBoxSpot;
	}

	void ConnectRandomHotSpot( RandomHotSpot &aRandomHotSpot )
	{
		myRandomHotSpotConnex = &aRandomHotSpot;
	}

	std::string GetRandomHotSpotID( )
	{
		return myID;
	}

	RandomHotSpot *myRandomHotSpotConnex;

	float myHeight;
	float myWidth;

private:

	std::string myID;

	Vector4<float> myBoxSpot;

	RandomHotSpot( )
	{

	}
};


#endif