#ifndef SOUND_SYSTEM_HEADER_
#define SOUND_SYSTEM_HEADER_

#include "FMOD\inc\fmod.hpp"
#include <vector>
#include <string>

struct SoundData
{

	std::string myID;
	std::string mySoundSource;
	FMOD::Sound *mySound;
	FMOD::Channel *myChannel;

	SoundData(std::string aID, std::string aSoundSource):
	myID(aID), mySoundSource(aSoundSource)
	{}
};
class SoundSystem
{
public:
	static void Create();
	static void Destroy();
	static SoundSystem &Instance();

	void PlayMusic();
	void PlayThisMusic(std::string musicID);
	void ChangeMusic(std::string musicID);
	void AllMusicStop();
	void Update();

private:
	static SoundSystem *ourInstance;

	SoundSystem();
	~SoundSystem();

	void Init();
	int GetIndex(std::string aSoundID);

	FMOD::System *myMusicSystem;
	FMOD::Sound *myBackgroundStream;
	FMOD::Channel *myBackgroundChannel;

	std::vector<SoundData> mySoundList;
	std::string myCurrentSound;

	/*FMOD::Sound *myLaserBackgroundStream;
	FMOD::Sound *myStepSound;
	FMOD::Sound *myCrystalSound;
	FMOD::Sound *myLaserTurnSound;
	FMOD::Sound *myLaserSlideSound;*/
	/*FMOD::Channel *myLaserBackgroundChannel;
	FMOD::Channel *myStepChannel;
	FMOD::Channel *myCrystalChannel;
	FMOD::Channel *myLaserTurnChannel;
	FMOD::Channel *myLaserSlideChannel;*/
};

#endif // SOUND_SYSTEM_HEADER_
