#ifndef	_SPRITE_H_
#define _SPRITE_H_
#define PI 3,14159
#define DEGREE_TO_RADIAN(degree) (degree * (PI/180))
#define RADIAN_TO_DEGREE(radian) (radian * (180/PI))

#include "HGE\hge.h"
#include "HGE\hgeSprite.h"
#include <string>
#include "Vector.h"

class Sprite
{
public:

	Sprite();
	Sprite(HGE* aHGE);							
	Sprite(const Sprite& aSprite);
	~Sprite();

	// set function
	void SetPosition(const float aPositionX, const float aPositionY);
	void SetPosition(const Vector2<float> aPosition);
	void SetScales(const float aScaleX, const float aScaleY);
	void SetScales(const Vector2<float> aScale);
	void SetRotation(const float aDegree);
	void SetVisible(bool isVisible);

	// get function
	Vector2<float> GetPosition();
	Vector2<float> GetScalse();
	float GetRotation();

	float GetSpriteWidth();
	float GetSpriteHeight();


	virtual void Initialize() = 0;
	virtual void Render(float) = 0;

protected:

	HGE* myHGE;
	HTEXTURE myTexture;
	hgeSprite* mySprite;
	
	Vector2<float> myPosition;
	Vector2<float> myScale;
	float myRotation;

	float mySpriteWidth;
	float mySpriteHeight;

	float myTextureWidth; 
	float myTextureHeight;

	float myZValue;

	bool myIsVisible;
};
#endif