#include "StartScreen.h"

StartScreen::StartScreen()
{
}
StartScreen::StartScreen(HGE *aHGE):
myHGE(aHGE)
{
	myStartScreenSprite = StaticSprite(aHGE, "img/CutsceneImages/mainscreen.dds");

	myIntro = Intro(aHGE);

	startTheGame = false;
	myStartIntro = false;

	myPosition = Vector2<float>(0.0f , 0.0f);
}
StartScreen::StartScreen(const StartScreen &aStartScreen):
myHGE(aStartScreen.myHGE)
{
	myStartScreenSprite = aStartScreen.myStartScreenSprite;

	myIntro = aStartScreen.myIntro;

	startTheGame = aStartScreen.startTheGame;
	myStartIntro = aStartScreen.myStartIntro;

	myPosition = aStartScreen.myPosition;

}
StartScreen::~StartScreen()
{
}

void StartScreen::StartScreenScene(float aElapseTime)
{
	if(myStartIntro == true)
	{
		myIntro.PlayIntro(aElapseTime);
	}
	if(myIntro.myIntroHasPlayed == true)
	{
		startTheGame = true;
	}
}
void StartScreen::Input(InputWrapper &aInputWrapper)
{
	if(myStartIntro == true)
	{
		myIntro.Input(aInputWrapper);
	}
	else
	{
		if(aInputWrapper.KeyPressed(DIK_RETURN))
		{
			myStartIntro = true;
		}
	}
}
void StartScreen::Render(RenderData &someRenderData)
{
	if(myStartIntro == true)
	{
		myIntro.Render(someRenderData);
	}
	else
	{
		RenderMessage tempMessage;

		tempMessage.myPosition = myPosition;
		tempMessage.myType = spriteRenderMessageType;
		someRenderData.myMessages.push_back(tempMessage);
		someRenderData.mySprites.push_back(&myStartScreenSprite);
	}
}
