#include "StaticSprite.h"
StaticSprite::StaticSprite( )
{
}
StaticSprite::StaticSprite(HGE *aHge)
: Sprite(aHge)
{
}
StaticSprite::StaticSprite(HGE *aHge, std::string aTextureName)
: Sprite(aHge)
{
	myTexture = myHGE->Texture_Load(aTextureName.c_str());
	assert(myTexture && "Can't load in the texture");

	mySpriteWidth = static_cast<float>(myHGE->Texture_GetWidth(myTexture, false));		
	mySpriteHeight = static_cast<float>(myHGE->Texture_GetHeight(myTexture, false));

	myPosition = Vector2<float>(0.0f, 0.0f);
	myRotation = 0.0f;
	myScale = Vector2<float>(1.0f, 1.0f);
	myZValue = 0;
	
	mySprite = new hgeSprite(myTexture, myPosition.x, myPosition.y, mySpriteWidth, mySpriteHeight);
	mySprite->SetZ(0.0f, 4);
	//mySprite->SetBlendMode(BLEND_ALPHAADD);
}

StaticSprite::~StaticSprite()
{
}

void StaticSprite::Initialize()
{}
void StaticSprite::Update(float aDeltaTime)
{
	aDeltaTime = aDeltaTime;	// avoid the warning.
}
void StaticSprite::Render(float aDeltaTime)
{
	aDeltaTime = aDeltaTime;	// avoid the warning.
	if(myIsVisible == true)
	{
		mySprite->RenderEx(myPosition.x, myPosition.y, myRotation, myScale.x, myScale.y);
	}
}

void StaticSprite::RenderAtPosition(Vector2<float> aPosition)
{
	if(myIsVisible == true)
	{
		mySprite->RenderEx(aPosition.x, aPosition.y, 0.0f, 1.0f, 1.0f);
	}
}

void StaticSprite::SetTexture(HTEXTURE aTextureName)
{
	mySprite->SetTexture(aTextureName);
}
void StaticSprite::SetColor(Vector4<int> aColor)
{
	mySprite->SetColor( ARGB( aColor.a, aColor.r, aColor.g, aColor.b ) );
}