#ifndef ___THREAD_SHARED_DATA_H___
#define ___THREAD_SHARED_DATA_H___

#include "HGE\hge.h"

#include "Avatar.h"
#include "Robot.h"
#include "Inventory.h"
#include "Notebook.h"

#include "DeepJungle.h"
#include "Village.h"
#include "Vulcano.h"
#include "Cave.h"
#include "JungleCrashSite.h"
#include "TimeMachine.h"
#include "BlownUpCave.h"

#include "CollisionMap.h"
#include "ConversationHotSpot.h"
#include "VerticalHotSpot.h"
#include "Camera.h"
#include "Cursor.h"
#include "Curtain.h"
#include "SoundSystem.h"
#include "Vector.h"
#include "Font.h"
#include "Timer\TimerManager.h"

#include <bitset>
#include <vector>
#include "QuitMsgBox.h"
#include "Intro.h"
#include "StartScreen.h"
#include "Outro.h"
#include "QuitMenu.h"


class ThreadSharedData
{

public:

	ThreadSharedData( );
	~ThreadSharedData( );
	
	void Initialize( HGE *aHGE , Vector2<float> aScreenDimensions );
	void LevelConversationInit();
	void HandleInput(InputWrapper &aInputWrapper, float aDelta);
	void Update(InputWrapper &aInputWrapper, float aDelta);
	void Render(InputWrapper &aInputWrapper, int aActiveRenderDataIndex);
	void CheckLevelChange( );

	bool threadLogicStart;
	bool threadGraphicStart;
	bool threadLogicDone;
	bool threadGraphicDone;
	bool quitGame;
	int logicIndex,
		graphicIndex;	
	float myConversationDelta;

	std::vector<RenderData> myRenderData;
	Tools::TimerManager myTimerFactory;
	Tools::Timer *myInGameTimer;
	Tools::Timer *myLogicTimer;
	HGE *myHGE;
	
	Inventory myInventory;
	Notebook myNotebook;

	Avatar myAvatar;
	Cursor myCursor;	
	Camera myCamera;
	Curtain myCurtain;

	JungleCrashSite myJungleCrashSiteLevel;
	DeepJungle myDeepJungleLevel;
	TimeMachine myTimeMachineLevel;
	Village myVillageLevel;
	Vulcano myVulcanoLevel;
	Cave myCaveLevel;
	BlownUpCave myBlownUpCaveLevel;

	LevelBaseData* myActiveLevel;

	QuitMsgBox myQuitMsgBox;
	StartScreen myStartScreen;
	Outro myOutro;
	QuitMenu myQuitMenu;

private:

};


#endif