#include <Windows.h>
#include <assert.h>

#include "TGASystemTimer.h"
#include "TGATime.h"

Tools::TGASystemTimer::TGASystemTimer(void)
{		
	QueryPerformanceCounter(&myStartTime);
	myLastUpdateTime = myStartTime;
	QueryPerformanceFrequency(&myFrequency);	

	myMasterTimer = NULL;
}

Tools::TGASystemTimer::TGASystemTimer(TGASystemTimer &aTGASystemTimer)
{
	myStartTime = aTGASystemTimer.myStartTime;
	myFrequency = aTGASystemTimer.myFrequency;
	myMasterTimer = aTGASystemTimer.myMasterTimer;
	myLastUpdateTime = aTGASystemTimer.myLastUpdateTime;
}

Tools::TGASystemTimer::~TGASystemTimer(void)
{
}

void Tools::TGASystemTimer::Update()
{
	if ( myMasterTimer != NULL )
	{
		TGATime update(0);
		LARGE_INTEGER currentTime;
		QueryPerformanceCounter(&currentTime);
		long long cyclesSinceLast = currentTime.QuadPart - myLastUpdateTime.QuadPart;
		double secondsSinceLast = static_cast<double>(cyclesSinceLast) / static_cast<double>(myFrequency.QuadPart);
		update.myTime = secondsSinceLast;	
		myMasterTimer->Update(update);
		myLastUpdateTime = currentTime;
	}
	else
	{
		assert (0);
		printf ("TGASYSTEMTIMER ERROR: Update called without a MasterTimer.");
	}
}

void Tools::TGASystemTimer::SetMasterTimer(Tools::Timer &aMasterTimer)
{
	myMasterTimer = &aMasterTimer;
}