#include "TGATime.h"

const float Tools::TGATime::MilisecontInSecond = 1000.0f;
const float Tools::TGATime::SecondsInMinute = 60.0f;
const float Tools::TGATime::MinutesInHour = 60.0f;
const float Tools::TGATime::HoursInDay = 24.0f;

Tools::TGATime::~TGATime(void)
{
}

Tools::TGATime::TGATime()
{
	myTime = 0;
}

Tools::TGATime::TGATime(double aTimeInSeconds)
{
	myTime = aTimeInSeconds;
}

Tools::TGATime::TGATime(long long aTimeInSeconds)
{
	myTime = static_cast<double> (aTimeInSeconds);
}

Tools::TGATime::TGATime(int aTimeInSeconds)
{
	myTime = static_cast<double> (aTimeInSeconds);
}

Tools::TGATime::TGATime(TGATime &aTGATime)
{
	myTime = aTGATime.myTime;
}

float Tools::TGATime::GetMiliSeconds()
{
	return static_cast<float> ( myTime * MilisecontInSecond );
}

float Tools::TGATime::GetSeconds()
{
	return static_cast<float> ( myTime );
}

float Tools::TGATime::GetMinutes()
{
	return static_cast<float> ( myTime / SecondsInMinute );
}

float Tools::TGATime::GetHours()
{
	return static_cast<float> ( GetMinutes() / MinutesInHour );
}

float Tools::TGATime::GetDays()
{
	return static_cast<float> ( GetHours() / HoursInDay );
}

Tools::TGATime Tools::TGATime::operator -(const Tools::TGATime &aTGATime)
{
	Tools::TGATime temp;
	temp.myTime = myTime - aTGATime.myTime;
	return temp;
}

Tools::TGATime Tools::TGATime::operator =(const Tools::TGATime &aTGATime)
{
	myTime = aTGATime.myTime;
	return (*this);
}