#include "Timer.h"
#include "TGATime.h"
#include "TGASystemTimer.h"

Tools::Timer::Timer()
{
	myLastUpdate = TGATime(0);
	myElapsedTime = TGATime(0);
	myPaused = false;
}

Tools::Timer::~Timer(void)
{
}

Tools::Timer::Timer(const Timer &aTimer)
{
	myLastUpdate = aTimer.myLastUpdate;
	myElapsedTime = aTimer.myElapsedTime;
	myPaused = aTimer.myPaused;
}

Tools::TGATime Tools::Timer::GetElapsedTime()
{
	return myElapsedTime;
}

void Tools::Timer::Update(TGATime aTimeUpdate)
{
	if ( myPaused == false )
	{
		myElapsedTime.myTime += aTimeUpdate.myTime;
		for(unsigned int childUpdated = 0; childUpdated < myChildren.size(); childUpdated++)
		{
			myChildren[childUpdated]->Update(aTimeUpdate);
		}
	}
}

void Tools::Timer::AddChild(Timer &aChildTimer)
{
	myChildren.push_back(&aChildTimer);
}

void Tools::Timer::StartTimer()
{
	myPaused = false;
}

void Tools::Timer::PauseTimer()
{
	myPaused = true;
}

void Tools::Timer::SwitchTimerOnOff()
{
	if ( myPaused == true)
	{
		myPaused = false;
	}
	else
	{
		myPaused = true;
	}
}

Tools::TGATime Tools::Timer::GetDelta()
{
	Tools::TGATime delta;
	delta = (myElapsedTime - myLastUpdate);
	myLastUpdate = myElapsedTime;
	return delta;
}