#ifndef _TIMER_H_
#define _TIMER_H_

#include <vector>

#include "TGATime.h"

class TimerManager;

namespace Tools
{
	class Timer
	{
	public:
		Timer(void);
		Timer(const Timer &aTimer);
		~Timer(void);

		TGATime	GetElapsedTime();
		TGATime GetDelta();
		void AddChild(Timer &aChildTimer);
		void Update(TGATime aTime);
		void PauseTimer();
		void StartTimer();
		void SwitchTimerOnOff();
		
		
		std::vector<Timer*> myChildren; // should be private, is not for testing purposes

	private:
		TGATime myLastUpdate;
		TGATime myElapsedTime;
		bool myPaused;
		

	};
}

#endif // _TIMER_H_
