#include <iostream>

#include "TimerManager.h"
#include "TGASystemTimer.h"
#include "Timer.h"
#include "TGATime.h"

Tools::TimerManager::TimerManager(void)
{
	myTGASystemTimer = TGASystemTimer();
	myTimers.reserve(10000);
	myTimers.push_back(Timer());
	myTGASystemTimer.SetMasterTimer(myTimers[0]);
}

Tools::TimerManager::~TimerManager(void)
{
}

Tools::Timer& Tools::TimerManager::CreateTimer()
{
	myTimers.push_back(Timer());
	return myTimers[myTimers.size()-1];
}

Tools::Timer& Tools::TimerManager::GetMasterTimer()
{
	return myTimers[0];
}

void Tools::TimerManager::TestTimers()
{
	while (myTimers[0].GetElapsedTime().GetSeconds() <= 120)
	{
		myTGASystemTimer.Update();
		system("cls");		
		for ( unsigned int timerPrinted = 0; timerPrinted < myTimers.size(); timerPrinted++)
		{
			if ( myTimers[timerPrinted].GetElapsedTime().GetSeconds() == 5 && myTimers[timerPrinted].myChildren.size() == 0)
			{
				Tools::Timer &newTimer = CreateTimer();
				myTimers[timerPrinted].AddChild(newTimer);			
			}

			std::cout << "Time elapsed since Timer" << timerPrinted << " started: "
				//<< myTimerManager.GetTimeSinceStart().GetMiliSeconds() << " miliSeconds" << std::endl		
				<< myTimers[timerPrinted].GetElapsedTime().GetMiliSeconds() << " MiliSeconds" << std::endl
				//<< myTimerManager.GetTimeSinceStart().GetMinutes() << " minutes" << std::endl	
				//<< myTimerManager.GetTimeSinceStart().GetHours() << " hours" << std::endl	
				//<< myTimerManager.GetTimeSinceStart().GetDays() << " days" << std::endl
				;
		}
	}
}

void Tools::TimerManager::UpdateTimers()
{
	myTGASystemTimer.Update();
}
