#ifndef _TIMEMANAGER_H_
#define _TIMEMANAGER_H_

#include <vector>

#include "TGASystemTimer.h"
#include "Timer.h"
#include "TGATime.h"

namespace Tools
{
	class TimerManager
	{
		public:
			TimerManager(void);
			~TimerManager(void);

			void TestTimers();
			Timer& CreateTimer();
			Timer& GetMasterTimer();
			void UpdateTimers();

		private:
			
			TGASystemTimer myTGASystemTimer;
			std::vector<Timer> myTimers;
	};
}

/* 
	Example of timer use
	Tools::TimerManager myTimeManager;

	Tools::Timer &myMasterTimer = myTimeManager.GetMasterTimer();
	Tools::Timer &myChildTimer = myTimeManager.CreateTimer();
	myMasterTimer.AddChild(myChildTimer);

	for (;;)
	{
		myTimeManager.UpdateTimers();		
		std::cout << myMasterTimer.GetElapsedTime().GetMiliSeconds() << " " 
			<< myChildTimer.GetElapsedTime().GetMiliSeconds() << std::endl;
		//system("PAUSE");
	}
*/


#endif // _TIMEMANAGER_H_
