#include "Villager.h"


Villager::Villager()
{
}

Villager::Villager( HGE* aHGE, std::string aFileName, Vector2<float> aWorldSpacePosition )
{
	mySprite = StaticSprite(aHGE, aFileName);
	myWorldSpacePosition = aWorldSpacePosition;

	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

Villager::Villager(HGE* aHGE)
:myHGE(aHGE)
{	
	mySprite = StaticSprite(myHGE, "img/NPCs/sprite_Woman.dds");
	myWorldSpacePosition = Vector2<float>(690.0f, 630.0f);
	
	myInterractionButton = StaticSprite( aHGE, "img/icon/icon_e.dds" );
}

Villager::~Villager()
{
}

void Villager::InputHandling(InputWrapper& aInput)
{
	aInput;
	SwitchState( );
}

void Villager::Render(RenderData &someRenderData)
{
	RenderMessage tempMessage;

	tempMessage.myPosition = myCameraSpacePosition;
	tempMessage.myType = spriteRenderMessageType;

	someRenderData.myMessages.push_back(tempMessage);
	someRenderData.mySprites.push_back(&mySprite);

	if(IsInterractable() == true)
	{
		tempMessage.myPosition = Vector2<float>( myCameraSpacePosition.myX + 30, myCameraSpacePosition.myY - 60);
		tempMessage.myType = spriteRenderMessageType;

		someRenderData.myMessages.push_back( tempMessage );
		someRenderData.mySprites.push_back( &myInterractionButton );
	}
}

void Villager::Update(Vector2<float> aCameraPosition, Vector2<float>& anAvatarPosition)
{
	myCameraSpacePosition = myWorldSpacePosition - aCameraPosition;
	IsAvatarInProximity(anAvatarPosition);
}

bool Villager::IsAvatarInProximity(Vector2<float>& anAvatarPosition)
{
	if( (anAvatarPosition.myX < myWorldSpacePosition.myX + 130) && (anAvatarPosition.myX > myWorldSpacePosition.myX - 130) )
	{
		if( (anAvatarPosition.myY < myWorldSpacePosition.myY + 130) && (anAvatarPosition.myY > myWorldSpacePosition.myY - 130) )
		{
			MakeInterractable();
			return true;
		}
	}

	MakeNotInterractable();
	return false;
}

bool Villager::IsInterractable()
{
	return (myAvatarNear);
}

void Villager::MakeInterractable()
{
	myAvatarNear = true;
}

void Villager::MakeNotInterractable()
{
	myAvatarNear = false;
}

void Villager::SwitchState()
{
	if( IsActive() == false )
	{
		MakeActive();
	}
	else
	{
		MakeNotActive();
	}
}

void Villager::MakeActive()
{
	myIsBeingCalled = true;
}

void Villager::MakeNotActive()
{
	myIsBeingCalled = false;
}

bool Villager::IsActive()
{
	if(myIsBeingCalled == true)
	{
		return true;
	}
	return false;
}

