#pragma once
#include "levelbasedata.h"
#include "Curtain.h"

#include "RandomHotSpot.h"

class Vulcano :
	public LevelBaseData
{
public:
	Vulcano();
	Vulcano(const LevelBaseData& aLevelBaseData);
	~Vulcano(void);

	void RenderOverlay(RenderData &aRenderData, Camera &aCamera);
	void LevelSpecificUpdate(Avatar &aAvatar, Camera &aCamera, float aDelta);
	void LevelSpecificRender(RenderData &aRenderData, Camera &aCamera);
	void LevelSpecificHandleInput(InputWrapper &aInputWrapper, float aDelta, Inventory &aInventory);
	virtual void ConversationEvent(float elapsTime, Avatar &aAvatar, Inventory &aInventory);

	void InitializeConversations();

	void Initialize(HGE *aHGE);

	Curtain myCurtain;

	bool myMoveAvatarToNest;
	bool myAvaterHaveSavedTheChildren;
	bool myClimbingDownTree;
	bool myClimbedDownFromTree;
	bool myVulcanoClimbable;
	bool myTravelDown;
	bool myTravelUp;
	bool myStairUpCreated;
	bool myChildrenSaved;
	float myClimbingTimer;

	Item* myBoy;
	Item* myGirl;

	Item myPalmOverlay;
};
