#pragma once

#include "StaticSprite.h"
#include "RenderInformation.h"
#include <vector>

class Map
{
public:
	Map(void);
	~Map(void);

	void AddFloorSprite(StaticSprite aSprite, Vector2<float> aPosition);
	void AddOverlaySprite(StaticSprite aSprite, Vector2<float> aPosition);

	void RenderFloor(RenderData &someRenderData, Vector2<float> aCameraPosition);
	void RenderOverlay(RenderData &someRenderData, Vector2<float> aCameraPosition);

	int GetMapWidth();
	int GetMapHeight();
	
private:

	std::vector<StaticSprite> myFloor;
	std::vector<Vector2<float>> myFloorPosition;
	std::vector<StaticSprite> myOverlay;
	std::vector<Vector2<float>> myOverlayPosition;
};
